/*
	blood.c
	Description: Es raro un juego mio que no tenga un modulo por separado para
	la sangre ;-)
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/

#include <allegro.h>
#include <malloc.h>
#include <string.h>
#include "blood.h"
#include "trans.h"
#include "log.h"

BLOODSPOT * ph_init_bloodspot(void)
{
BLOODSPOT *aux;

	ph_log(_("- Initiating particles: "));
	aux=(struct BLOODSPOT *)malloc(sizeof(struct BLOODSPOT));
	if (aux==NULL) ph_log_memory_error("blood.c","ph_init_bloodspot","aux",
		sizeof(struct BLOODSPOT));
	memset(aux,0,sizeof(struct BLOODSPOT));
	ph_log(_("Ok.\n"));
	return aux;
}


void ph_destroy_bloodspot(BLOODSPOT *bs)
{
	free(bs);
}


void ph_create_bloodspot(BLOODSPOT *bs, unsigned char amount, 
	signed short int x, signed short int y)
{
int i;

	for (i=0;i<amount;i++)
	{
		bs->active[bs->actbspot]=1;
		bs->x[bs->actbspot]=x+8+rand()%16;
		bs->y[bs->actbspot]=y+8+rand()%16;
		bs->dir[bs->actbspot]=rand()%8;
		bs->xspeed[bs->actbspot]=(rand()%3)+1;
		bs->yspeed[bs->actbspot]=(rand()%3)+1;
		bs->duration[bs->actbspot]=(rand()%15)+1;
		
		switch(bs->dir[bs->actbspot])
		{
			case 0: 
				bs->xspeed[bs->actbspot]=0;bs->yspeed[bs->actbspot]*=-1;break;
			case 1: 
				bs->yspeed[bs->actbspot]*=-1;break;
			case 7: 
				bs->yspeed[bs->actbspot]*=-1;bs->xspeed[bs->actbspot]*=-1;break;
			case 2: 
				bs->yspeed[bs->actbspot]=0;break;
			case 4: 
				bs->xspeed[bs->actbspot]=0;break;
			case 5: 
				bs->xspeed[bs->actbspot]*=-1;break;
			case 6: 
				bs->xspeed[bs->actbspot]*=-1;break;
		}
		bs->actbspot++;
		
		if (bs->actbspot>=MAXBLOODSPOTS) bs->actbspot=0;
	}
}


void ph_move_bloodspot(BLOODSPOT *bs, GFX *gfx)
{
unsigned int i;
	

	for (i=0;i<MAXBLOODSPOTS;i++)
	{
		if (bs->active[i])
		{
			bs->x[i]+=bs->xspeed[i];
			bs->y[i]+=bs->yspeed[i];
			bs->duration[i]--;
			if (bs->duration[i]<=0) bs->active[i]=0;
		}
	}
}


void ph_draw_blood(BLOODSPOT *bs, GFX *gfx)
{
unsigned int i;

	set_trans_blender(127,127,127,127);
	drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
	
	for (i=0;i<MAXBLOODSPOTS;i++)
	{
		if (bs->active[i])
		{
			putpixel(gfx->virt[0],bs->x[i],bs->y[i],makecol((rand()%55)+200,rand()%20,rand()%20));
			putpixel(gfx->virt[0],bs->x[i],bs->y[i]+1,makecol((rand()%10)+100,rand()%10,rand()%10));
			putpixel(gfx->virt[0],bs->x[i]+1,bs->y[i],makecol((rand()%55)+200,rand()%20,rand()%20));
			putpixel(gfx->virt[0],bs->x[i]+1,bs->y[i]+1,makecol((rand()%10)+100,rand()%10,rand()%10));
		}
	}

	set_trans_blender(255,255,255,255);
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

}


void ph_remove_bloodspot(BLOODSPOT *bs)
{
unsigned int i;

	for (i=0;i<MAXBLOODSPOTS;i++) bs->active[i]=0;
}
