/*
	game.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#include "config.h"
#include "game.h"
#include "gfx.h"
#include "player.h"
#include "control.h"
#include "control2.h"
#include "world.h"
#include "luaphant.h"
#include "platform.h"
#include "switch.h"
#include "trans.h"
#include "energy.h"
#include "path.h"
#include "back.h"
#include "texter.h"
#include "intro.h"
#include "ppcd.h"
#include "phttp1.h"
#include "phantom1.h"
#include "records2.h"
#include "traps.h"
#include "arrows.h"
#include "block.h"


void ph_start_game(PROGRAM *p)
{
HAND *hand;
BLOCK *bl;
ARROWS *ar;
TMENU *menu;
PHFONT *pfont;
DATA *data;
ENEMY *ene;
GFX *gfx;
CONTROL *c;
PLAYER *pl;
CFG *cfg;
WORLD *w;
BLOODSPOT *bs;
PLATFORM *plat;
SWITCH *sw;
ENERGY *energy;
SOUND *sound;
int i;
char done=0;
int xj=0;
//int acycle=0;
int wi;
int he;
int playerx;
int playery;
int platx;
int platy;
char event[10];
// char resting=0;
char allow_jump=0;
char ilife=0;
//char debug=0;
unsigned char bc1,bc2,bc3=0;
static char back7=0;

	event[0]=0;
	event[1]=0;
	event[2]=0;
	event[3]=0;
	event[4]=0;
	event[5]=0;
	event[6]=0;
	event[7]=0;
	ar=p->ar;
	w=p->w;
	gfx=p->gfx;
	c=p->c;
	ene=p->ene;
	hand=p->hand;
	data=p->data;
	pl=p->pl;
	plat=p->plat;
	cfg=p->cfg;
	bs=p->bs;
	bl=p->bl;
	sw=p->sw;
	pfont=p->fnt;
	energy=p->energy;
	sound=p->snd;
	menu=p->menu;
	p->cfg->autoframeskip=1;
	pl->x=itofix(64);
	pl->right=1;
	pl->aniframe=1;
	pl->y=itofix(104);
	pl->speed=4;
	pl->jumping=0;
	pl->energy=238;
	pl->cheats=0;
	pl->pressed_switches=0;
	pl->treasure=0;
	pl->safe=0;
	w->actroom=0;
	pl->opendoor=0;
	menu->ingame=1;
	p->b->active=0;
	xj=0;
	
	w=ph_load_world_data_alt(w,p->data);
	lua_dofile(p->ls,ph_get_path(p->cfg,p->path,"scripts/world.lua"));

	ph_get_room_data(w,w->actroom,pl);
	ph_change_room(p,w->actroom);
	p->cfg->autoframeskip=1;
	
	if (p->cfg->stretch)
	{
		stretch_blit(data->dgfx[PHANTGFX_DAT_MISFONDO_BMP].dat,screen,0,0,p->cfg->xres,p->cfg->yres,0,0,p->cfg->stretchx,p->cfg->stretchy);
	}
	else
	{
		blit(data->dgfx[PHANTGFX_DAT_MISFONDO_BMP].dat,screen,0,0,0,0,p->cfg->xres,p->cfg->yres);
	}
	
	#if HAVE_ALDUMB_H
		if (cfg->music && cfg->enable_sound)
			sound->music->mpl = al_start_duh(sound->music->duh, 2, 0, 1.0f,4096,22100);
	#endif
	set_trans_blender(127,127,127,127);
	clear_to_color(gfx->virt[0],makecol(0,0,0));
	ph_set_text_properties(pfont,makecol(255,255,255),-1,TXT_TITLE,TXT_LEFT,13,0,1);
	p->t->acycle=p->t->target_cycle=0;
	menu->showmenu=0;
	
	ph_log(_("- Entering main loop...\n"));
	
	while(1)
	{
		c=ph_read_control(p,c,menu,pfont);

/* 		if (key[KEY_TAB]) debug^=1;*/
// 		
// 		if (key[KEY_L]) 
// 		{
// 			fixtoi(pl->y);
// 			pl->y=0;
// 		}
// 		
// 		if (key[KEY_S])
// 		{
// 			ph_save(p);
// 		}
// 		
// 		if (key[KEY_L])
// 		{
// 			p=ph_load_game(p);
// 		
// 		}
/*		if (key[KEY_V]) 
		{
			w->actroom++;
			ph_change_room(p,w->actroom);
			ph_get_room_data(w,w->actroom,pl);
		}
		if (key[KEY_B]) 
		{
			w->actroom--;
			ph_change_room(p,w->actroom);
			ph_get_room_data(w,w->actroom,pl);
		}*/
// 		if (key[KEY_R]) 
// 		{
// 			lua_dofile(p->ls,ph_get_path(p->cfg,p->path,"scripts/world.lua"));
// 			ph_change_room(p,w->actroom);
// 			ph_get_room_data(w,w->actroom,pl);
// 		}
		
		if (key[KEY_A] && key[KEY_B] && key[KEY_U] && pl->cheats)
		{
			pl->abu=1;
		}
		
		if (key[KEY_E] && key[KEY_N] && key[KEY_T] && key[KEY_H] && pl->cheats)
		{
			allow_jump=1;
		}
		
		if (key[KEY_1] && key[KEY_0] && key[KEY_8] && pl->cheats)
		{
			ilife=1;
		}
		
		if (key[KEY_E] && key[KEY_K] && key[KEY_O] && key[KEY_P])
		{
			pl->cheats=1;
		}
		
		while(p->t->target_cycle>p->t->acycle && p->cfg->autoframeskip && !p->menu->showmenu)
		{
			pl->damaging=0;
			pl->onplatform=0;
			pl->falling=0;
			
			/* Menudo follon de codigo para controlar el movimiento correcto
			de las plataformas de subida y bajada */
			for (i=0;i<MAXPLATFORMS;i++)
			{
				if (plat->active[i])
				{
					wi=(int)gfx->plaspr[4*plat->type[(int)i]]->w;
					he=(int)gfx->plaspr[4*plat->type[(int)i]]->h;
					playerx=fixtoi(pl->x);
					playery=fixtoi(pl->y);
					platx=fixtoi(plat->x[(int)i]);
					platy=fixtoi(plat->y[(int)i]);
					
					if ((plat->up[(int)i]==2) && !(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)+32)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)+32)>>4])
					&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)+32)>>4]))
					{
						if ((((playerx+30)>=platx) && (playerx<=(platx+(wi-2))) && xj>=9) && 
						((playery+32)==platy || (playery+33)==platy ||
						(playery+34)==platy || (playery+35)==platy ||
						(playery+36)==platy || (playery+37)==platy ||
						(playery+38)==platy || (playery+39)==platy ||
						(playery+40)==platy || (playery+41)==platy ||
						(playery+42)==platy || (playery+43)==platy ||
						(playery+46)==platy || (playery+47)==platy ||
						(playery+44)==platy || (playery+45)==platy ||
						(playery+46)==platy))                                             
						{
							pl->y=fixsub(plat->y[i],itofix(32));
							pl->onplatform=i+1;
							pl->jumping=0;
							pl->falling=0;
						}
					}
					if ((plat->up[(int)i]!=2) && !(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)+32)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)+32)>>4])
					&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)+32)>>4]))
					{
						if ((((playerx+30)>=platx) && (playerx<=(platx+wi)-2) && xj>=9) &&
						((playery+32)==platy || (playery+33)==platy ||
						(playery+34)==platy || (playery+35)==platy ||
						(playery+36)==platy || (playery+37)==platy ||
						(playery+38)==platy || (playery+39)==platy ||
						(playery+40)==platy || (playery+41)==platy ||
						(playery+42)==platy || (playery+43)==platy ||
						(playery+46)==platy || (playery+47)==platy ||
						(playery+44)==platy || (playery+45)==platy ||
						(playery+46)==platy))
						{
							pl->y=fixsub(plat->y[i],itofix(32));
							pl->onplatform=i+1;
							pl->jumping=0;
							pl->falling=0;
						}
					}
				}
			}
			
			done=0;
			
			/* Si estamos en el limite de abajo entrar en una hab. nueva */
			if (pl->y>=itofix(256) && !done)
			{
				w->actroom+=8;
				pl->y=itofix((0));
				ph_clean_arrows(ar);
				ph_change_room(p,w->actroom);
				ph_get_room_data(w,w->actroom,pl);
				done=1;
			}
			
			/* Si estamos en el limite de arriba entrar en una hab. nueva */
			if (pl->y<=itofix(0) && !done && pl->jumping)
			{
				w->actroom-=8;
				pl->y=itofix(256);
				ph_clean_arrows(ar);
				ph_change_room(p,w->actroom);
				ph_get_room_data(w,w->actroom,pl);
				done=1;
			}
			
			/* Si no hay suelo y no estamos saltando caer */
			if (!pl->inchopper && !pl->inrocket)
			{
				if (!(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)+32)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)+32)>>4])
				&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)+32)>>4]) && !pl->jumping && !pl->onplatform)
				{
					pl->falling=1;
					pl->y=fixadd(pl->y,itofix(4));
					if (cfg->enable_sound && cfg->sfx)
						ph_play_sample(sound->sfx->walk,fixtoi(pl->x),cfg);
	
					if (!(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)+32)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)+32)>>4])
					&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)+32)>>4]) && !pl->jumping && !pl->onplatform)
					{
						pl->falling=1;
						pl->y=fixadd(pl->y,itofix(4));
						pl->aniframe=fixadd(pl->aniframe,itofix(1));
						if (fixtoi(pl->aniframe)==4) pl->aniframe=0;
					}
				}
			}
			/* Salto alto */
			if (c->up && !pl->falling && !pl->jumping && !bl->active)
			{
				pl->jumping=1;
				xj=0;
				if (cfg->enable_sound && cfg->sfx)
					ph_play_sample(sound->sfx->hjump,fixtoi(pl->x),cfg);
			}
			
			/* Salto bajo */
			if (c->down && !pl->falling && !pl->jumping && !bl->active)
			{
				pl->jumping=2;
				xj=0;
				if (cfg->enable_sound && cfg->sfx)
					ph_play_sample(sound->sfx->ljump,fixtoi(pl->x),cfg);
			}
			
			/* Control del salto */
			if (pl->jumping)
			{
				if (xj<18) 
				{
					if (xj<9)
					{
						/* Aumentar si no chocamos contra algo que haya arriba,
						si no volver al modo normal. */
						if (fixtoi(pl->x)==448)
						{
							pl->y=fixsub(pl->y,itofix(4));
						}
						else
						{
							if (!(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)-1)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)-1)>>4])
							&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)-1)>>4]))
							{
								pl->y=fixsub(pl->y,itofix(4));
								
								if (pl->jumping==1) 
								{
									if (!(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)-1)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)-1)>>4])
									&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)-1)>>4]))
									{
										pl->y=fixsub(pl->y,itofix(4));
									}
								} 
							}
						}
					}
					else
					{
						if (!(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)+32)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)+32)>>4])
						&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)+32)>>4]))
						{
							pl->y=fixadd(pl->y,itofix(4));

							if (pl->jumping==1) 
							{
								if (!(w->cross[(fixtoi(pl->x))>>4][(fixtoi(pl->y)+32)>>4]) && (!w->cross[(fixtoi(pl->x)+15)>>4][(fixtoi(pl->y)+32)>>4])
								&& (!w->cross[(fixtoi(pl->x)+31)>>4][(fixtoi(pl->y)+32)>>4]))
									pl->y=fixadd(pl->y,itofix(4)); 
							}
						}
						else
						{
							pl->jumping=0;
						}
					}
					
					if (pl->right) 
					{
						if (fixtoi(pl->x)==448)
						{
							pl->x=fixadd(pl->x,itofix(4));
							if (pl->jumping==2)	pl->x=fixadd(pl->x,itofix(4));
							w->actroom++;
							ph_clean_arrows(ar);
							ph_change_room(p,w->actroom);
							ph_get_room_data(w,w->actroom,pl);
							pl->x=itofix(0);
						}
						if (!(w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+31)>>4]) && (!w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+1)>>4])
						&& (!w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+15)>>4]))
						{
							pl->x=fixadd(pl->x,itofix(4));
							if (pl->jumping==2) 
							{
								if (!(w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+31)>>4]) && (!w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+1)>>4])
								&& (!w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+15)>>4]))
									pl->x=fixadd(pl->x,itofix(4));
							}
							
							if (fixtoi(pl->x)>=448) 
							{
								w->actroom++;
								ph_clean_arrows(ar);
								ph_change_room(p,w->actroom);
								ph_get_room_data(w,w->actroom,pl);
								pl->x=itofix(0);
							}
						}
					}
					else 
					{
						if (!(w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+31)>>4]) && (!w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+1)>>4])
						&& (!w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+15)>>4]))
						{
							pl->x=fixsub(pl->x,itofix(4));
							
							if (pl->jumping==2) 
							{
								if (!(w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+31)>>4]) && (!w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+1)>>4])
								&& (!w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+15)>>4]))
									pl->x=fixsub(pl->x,itofix(4));
							}
						}
						if (fixtoi(pl->x)<=0) 
						{
							w->actroom--;
							ph_clean_arrows(ar);
							ph_change_room(p,w->actroom);
							ph_get_room_data(w,w->actroom,pl);
							pl->x=itofix(448);
						}
					}
					xj++;
				}
				else
				{
					pl->jumping=0;
				}
			}
			
			/* Si se permite el salto controlado */
			if (allow_jump)
			{
				if ((c->left && pl->jumping) || (c->left && pl->falling)) pl->right=0;
				if ((c->right && pl->jumping) || (c->right && pl->falling)) pl->right=1;
			}
			
			/* Si pulsamos izquierda */
			if (c->left && !pl->falling && !pl->jumping && !pl->inrocket && !pl->inchopper) 
			{
				if (cfg->enable_sound && cfg->sfx)
				{
					ph_play_sample(sound->sfx->walk,fixtoi(pl->x),cfg);
					//play_sample(sound->sfx->walk,127,((255*fixtoi(pl->x))/cfg->xres),1400-(fixtoi(pl->y)*2),0);
				}
				if (pl->right)
				{
					pl->right=0;
					pl->aniframe=1;
				}
				else
				{
					
					if (fixtoi(pl->x)==0) 
					{
						w->actroom--;
						ph_clean_arrows(ar);
						ph_change_room(p,w->actroom);
						ph_get_room_data(w,w->actroom,pl);
						pl->x=itofix(448);
					}
					else
					{
						/* Si no nos chocamos avanzar */
						if (!(w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+31)>>4]) && (!w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+1)>>4])
						&& (!w->cross[(fixtoi(pl->x)-1)>>4][(fixtoi(pl->y)+15)>>4]))
						{
							pl->x=fixsub(pl->x,itofix(pl->speed));
						}
					}
					
					pl->aniframe=fixadd(pl->aniframe,itofix(1));
					if (fixtoi(pl->aniframe)==4) pl->aniframe=itofix(0);
				}
			}

			/* Si pulsamos derecha */
			if (c->right && !pl->falling && !pl->jumping && !pl->inrocket && !pl->inchopper) 
			{
				if (cfg->enable_sound && cfg->sfx)
				{
					ph_play_sample(sound->sfx->walk,fixtoi(pl->x),cfg);
//					play_sample(sound->sfx->walk,127,((255*fixtoi(pl->x))/cfg->xres),1400-(fixtoi(pl->y)*2),0);
				}
				if (!pl->right)
				{
					pl->right=1;
					pl->aniframe=1;
				}
				else
				{
					/* Cambiar de pantalla */
					if (fixtoi(pl->x)>=448) 
					{
						w->actroom++;
						ph_clean_arrows(ar);
						ph_change_room(p,w->actroom);
						ph_get_room_data(w,w->actroom,pl);
						pl->x=itofix(0);
					}
					else
					{
						/* Si no nos chocamos avanzar */
						if (!(w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+31)>>4]) && (!w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+1)>>4])
						&& (!w->cross[(fixtoi(pl->x)+32)>>4][(fixtoi(pl->y)+15)>>4]))
						{
							pl->x=fixadd(pl->x,ftofix(4));
						}
					}
					
					/* Cambiar animacion */
					pl->aniframe=fixadd(pl->aniframe,ftofix(1));
					if (fixtoi(pl->aniframe)==4) pl->aniframe=itofix(0);
				}
			}
			
// 			if (key[KEY_T]) resting^=1;
			
			ph_set_vehicles_data(p->v, p->w,pl);
			ph_move_ball(p->b);
			ph_move_vehicles(p->v,p->w,p->pl);
			ph_move_bloodspot(bs,gfx);
			ph_move_enemies(ene);
			
			/* Tratar lo de la bola */
// 			if (key[KEY_J])
// 			{
// 				ph_do_speccy(gfx,sound);
// 			}
// 			
			if (w->actroom==64 && fixtoi(pl->x)==96)
			{
				p->b->active=1;
			}
			
			if (w->actroom==64 && fixtoi(pl->x)>=248 && p->b->active==1)
			{
				ph_do_speccy(p);
				p->b->active=2;
				p->pl->inball=1;
				p->pl->ballspeed=248;
				p->t->acycle=p->t->target_cycle=0;
				w->actroom=67;
				ph_change_room(p,w->actroom);
				ph_get_room_data(w,w->actroom,pl);
			}
			
			if (w->actroom==56 && pl->explotedoor==1)
			{
				pl->explotedoor=2;
				ph_get_room_data(w,w->actroom,pl);
			}
			
			if (w->actroom==7)
			{
				pl->opendoor=1;
				back7++;
				if (back7==8) back7=0;
				switch(back7)
				{
					case 0:
						bc1=0;bc2=0;bc3=0;
						break;
					case 1:
						bc1=0;bc2=0;bc3=192;
						break;
					case 2:
						bc1=192;bc2=0;bc3=0;
						break;
					case 3:
						bc1=0;bc2=192;bc3=0;
						break;
					case 4:
						bc1=192;bc2=0;bc3=192;
						break;
					case 5:
						bc1=0;bc2=192;bc3=192;
						break;
					case 6:
						bc1=192;bc2=192;bc3=0;
						break;
					case 7:
						bc1=192;bc2=192;bc3=192;
						break;
				}
			}
			
			if (w->actroom==56 && !pl->treasure)
			{
				if (fixtoi(pl->x)>=32 && fixtoi(pl->x)<=60 && fixtoi(pl->y)<=64 && fixtoi(pl->y)>32)
				{
					pl->treasure=1;
					ph_get_room_data(w,w->actroom,pl);
				}
			}
			if (w->actroom==56 && pl->treasure)
			{
				ph_move_hand(hand,pl);
				ph_exp_damage_player(hand,pl,gfx,sound,cfg,data);
			}
			if (w->actroom==60)
			{
				ph_throw_arrows(ar,pl,w);
				ph_arrows_damage_player(ar,pl,gfx,sound,cfg,data);
				ph_move_arrows(ar);
			}
			if (w->actroom==61)
			{
				ph_throw_block(bl,pl);
				ph_move_block(bl,pl);
			}
			if (w->actroom==67)
			{
				ph_move_ball(p->b);
			}
			ph_move_platforms(plat,pl,w);
			ph_get_energy(energy,pl,gfx,sound,cfg);
			if (!ilife) ph_damage_player(ene,pl,gfx,bs,sound,cfg);
			ph_push_switch(sw,pl,gfx,sound,cfg);
			if (ph_special_cases(p)) xj=0;
			
			#if HAVE_ALDUMB_H
				if (cfg->music && cfg->enable_sound)
					al_poll_duh(sound->music->mpl);
			#endif
			
			
			if (p->cfg->autoframeskip) p->t->acycle++;
			
			/* Mirar eventos */
			if (p->pl->gametype==GAME_NORMAL)
			{
				if (p->t->acycle==17 && !event[0]) event[0]=1;
				if (pl->firsttimehit==1) 
				{
					event[1]=1;
					pl->firsttimehit=2;	
				}
				if (pl->firsttimeenergy==1) 
				{
					event[2]=1;
					pl->firsttimeenergy=2;	
				}
				if (pl->firsttimeswitch==1) 
				{
					event[3]=1;
					pl->firsttimeswitch=2;	
				}
				if (pl->pressed_switches==SWITCHES_TO_OPEN_SAFE && !event[4]) 
				{
					event[4]=1;
				}
				if (pl->pressed_switches>=SWITCHES_TO_OPEN_SAFE && !event[5] && w->actroom==16 && fixtoi(pl->x)==32 && fixtoi(pl->y)==64) 
				{
					event[5]=1;
					pl->safe=1;
				}
				if (!event[6] && w->actroom==64 && fixtoi(pl->x)==96 && fixtoi(pl->y)==224) 
				{
					event[6]=1;
				}
				if (!event[7] && w->actroom==64 && fixtoi(pl->x)>=220 && event[6]) 
				{
					event[7]=1;
				}
			}
			rest(1);
		}
		
		if (w->actroom==67 && p->pl->inball && fixtoi(p->pl->x)<=110)
		{
			p->pl->energy=0;
		}
		
		if (w->actroom==67 && p->pl->inball && fixtoi(p->pl->x)>=440)
		{
			w->actroom=65;
			pl->x=itofix(0);
			pl->inball=0;
			ph_change_room(p,p->w->actroom);
			ph_get_room_data(p->w,p->w->actroom,pl);
		}
		
		/* Dibujar fondo especial */
		if (w->actroom==7)
		{
			rectfill(gfx->virt[0],0,0,480,288,makecol(bc1,bc2,bc3));
			vsync();
		}
		
		ph_draw_dec(p);
		if (w->actroom==2 || w->actroom==5 || w->actroom==65 || w->actroom==66) ph_draw_vehicles(p->v,data,gfx,w->actroom);
		if (w->actroom==5 && p->v->type==1)
		{
			p->v->type=2;
			p->v->x=176;
			p->v->y=112;
		}
		if (w->actroom==2 && p->v->type==2)
		{
			p->v->x=192;
			p->v->y=112;
			p->v->type=1;
		}
		
		ph_draw_platforms(plat,gfx);
		ph_draw_enemies(ene,gfx);
		

		if (p->v->ractive==3 && w->actroom==5)
		{
			w->actroom=66;
			ph_change_room(p,p->w->actroom);
			ph_get_room_data(p->w,p->w->actroom,pl);
		}
		if (p->v->ractive==5 && w->actroom==66)
		{
			w->actroom=5;
			ph_change_room(p,p->w->actroom);
			ph_get_room_data(p->w,p->w->actroom,pl);
		}
		if (p->v->active==3 && w->actroom==2)
		{
			w->actroom=65;
			ph_change_room(p,p->w->actroom);
			ph_get_room_data(p->w,p->w->actroom,pl);
		}
		if (p->v->active==6 && w->actroom==65)
		{
			w->actroom=2;
			ph_change_room(p,p->w->actroom);
			ph_get_room_data(p->w,p->w->actroom,pl);
		}
		
		if (w->actroom==31 && pl->safe && pl->treasure) 
		{
			pl->end=1;
			draw_sprite(gfx->virt[0],(BITMAP *)data->dgfx[PHANTGFX_DAT_DEC58_0_BMP].dat,272,192);
			draw_sprite(gfx->virt[0],(BITMAP *)data->dgfx[PHANTGFX_DAT_DEC57_0_BMP].dat,200,192);
			pl->x=itofix(32);
			pl->y=itofix(224);
		}
		
		
		if (w->actroom==16 && !pl->safe) draw_sprite(gfx->virt[0],(BITMAP *)data->dgfx[PHANTGFX_DAT_DEC22_0_BMP].dat,0,64);
		if (w->actroom==56 && !pl->treasure) draw_sprite(gfx->virt[0],(BITMAP *)data->dgfx[PHANTGFX_DAT_DEC79_0_BMP].dat,32,64);
		if (w->actroom==56 && pl->treasure) ph_draw_hand(hand,gfx,data);
		if (w->actroom==60) ph_draw_arrows(ar,data,gfx);
		if (w->actroom==61) ph_draw_block(bl,gfx,data);
		if (w->actroom==67) ph_draw_ball(p->b,gfx,data);
		
		ph_draw_energy(energy,gfx);
		ph_draw_switch(sw,gfx);
		
		/* Dibujar el sprite de Phantomas */
		if (w->actroom==7)
		{
			if (pl->right)
			{
				if (pl->falling) draw_sprite(gfx->virt[0],gfx->phspr[41+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
				if (pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[40],fixtoi(pl->x),fixtoi(pl->y));
				if (!pl->falling && !pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[36+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
			}
			else
			{
				if (pl->falling) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[41+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
				if (pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[40],fixtoi(pl->x),fixtoi(pl->y));
				if (!pl->falling && !pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[36+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
			}
		}
		else
		{
		if (!pl->inchopper && !pl->inrocket)
		{
			if (pl->right)
			{
				if (!pl->astro)
				{
					if (!pl->abu)
					{
						if (!pl->damaging)
						{
							if (pl->falling) draw_sprite(gfx->virt[0],gfx->phspr[5+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[4],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[0+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
						else
						{
							if (pl->falling) draw_sprite(gfx->virt[0],gfx->phspr[32+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[31],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[27+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
					}
					else
					{
						if (!pl->damaging)
						{
							if (pl->falling) draw_sprite(gfx->virt[0],gfx->phspr[23+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[22],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[18+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
						else
						{
							if (pl->falling) draw_sprite(gfx->virt[0],gfx->phspr[50+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[49],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[45+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
					}
				}
				else
				{
					if (pl->falling) draw_sprite(gfx->virt[0],gfx->phspr[14+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
					if (pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[13],fixtoi(pl->x),fixtoi(pl->y));
					if (!pl->falling && !pl->jumping) draw_sprite(gfx->virt[0],gfx->phspr[9+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
				}
			}
			else
			{
				if (!pl->astro)
				{
					if (!pl->abu)
					{
						if (!pl->damaging)
						{
							if (pl->falling) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[5+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[4],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[0+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
						else
						{
							if (pl->falling) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[32+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[31],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[27+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
					}
					else
					{
						if (!pl->damaging)
						{
							if (pl->falling) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[23+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[22],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[18+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
						else
						{
							if (pl->falling) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[50+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
							if (pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[49],fixtoi(pl->x),fixtoi(pl->y));
							if (!pl->falling && !pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[45+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
						}
					}
				}
				else
				{
					if (pl->falling) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[14+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
					if (pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[13],fixtoi(pl->x),fixtoi(pl->y));
					if (!pl->falling && !pl->jumping) draw_sprite_h_flip(gfx->virt[0],gfx->phspr[9+fixtoi(pl->aniframe)],fixtoi(pl->x),fixtoi(pl->y));
				}
			}
		}
		}
		ph_draw_blood(bs,gfx);
		if (pl->end) ph_game_end(p);
		
		/* Game over */
		if (pl->energy<=0) 
		{
			for (i=0;i<10;i++)
			{
				event[i]=0;
			}
			pl->energy=0;
			p=ph_game_over(p);
			p->pl->y=itofix(88+16);
			p->t->acycle=p->t->target_cycle=0;
		}
		

		/* Dibujar el marcador de vida, la caja fuerte y el tesoro */
		draw_sprite(gfx->virt[1],gfx->energy,0,0);
		set_trans_blender(127,127,127,127);
		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		rectfill(gfx->virt[1],238,0,pl->energy,15,makecol(40,40,40));
		set_trans_blender(255,255,255,255);
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		if (pl->safe)
		{
			draw_sprite(screen,gfx->decspr[22],100,390);
		}
		if (pl->treasure)
		{
			draw_sprite(screen,gfx->decspr[80],170,387);
		}

		if (menu->ingame) ph_draw_menu(p->fnt,gfx,menu,p->m);

		/* Si showtips llamar a las funciones de ensenar los mensajes */
		if (pl->showtips)
		{
			if (event[0]==1)
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,0);
				event[0]=2;
				ph_draw(gfx,cfg);
				p->t->acycle=0;p->t->target_cycle=0;
			}
			
			if (event[1])
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,1);
				event[1]=0;
				p->t->acycle=0;p->t->target_cycle=0;
				ph_draw(gfx,cfg);
			}
			
			if (event[2])
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,2);
				event[2]=0;
				p->t->acycle=0;p->t->target_cycle=0;
				ph_draw(gfx,cfg);
			}
			
			if (event[3])
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,3);
				event[3]=0;
				p->t->acycle=0;p->t->target_cycle=0;
				ph_draw(gfx,cfg);
			}

			if (event[4]==1)
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,4);
				event[4]=2;
				p->t->acycle=0;p->t->target_cycle=0;
				ph_draw(gfx,cfg);
			}

			if (event[5]==1)
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,5);
				event[5]=2;
				p->t->acycle=0;p->t->target_cycle=0;
				//w->decdata[8650]=2;
				ph_draw(gfx,cfg);
			}
			
			if (event[6]==1)
			{
				event[6]=2;
				p->t->acycle=0;p->t->target_cycle=0;
				ph_draw(gfx,cfg);
			}
			
			if (event[7]==1)
			{
				ph_in_game_message(c,gfx,data,cfg,sound,pl,pfont,7);
				event[7]=2;
				p->t->acycle=0;p->t->target_cycle=0;
				ph_draw(gfx,cfg);
			}
		}
		
		/* Mostrar algo de informacion de depuracion */
		/*
		if (debug)
		{
			set_trans_blender(200,200,200,200);
			drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
			rectfill(gfx->virt[0],0,0,150,40,makecol(50,50,50));
			set_trans_blender(255,255,255,255);
			drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
			ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,12,0,1);
			ph_printf(gfx->virt[0],p->fnt,10,10,"x:%d y:%d xm:%d ym:%d",fixtoi(pl->x),fixtoi(pl->y),fixtoi(pl->x)>>4,fixtoi(pl->y)>>4);
			ph_printf(gfx->virt[0],p->fnt,10,20,"room:%d life:%d switches:%d  -- %d -- %d",w->actroom,pl->energy,pl->pressed_switches,p->hand->xr,p->pl->ballspeed);
			set_trans_blender(255,255,255,255);
		}*/
//		w->decdata[50]=20;
		
		/* El gran blit :) */
		ph_draw(gfx,cfg);
	}
}


void ph_change_room(PROGRAM *p, int room)
{
PLATFORM *plat;
ENERGY *energy;
SWITCH *sw;
WORLD *w;
GFX *gfx;
DATA *data;
ENEMY *ene;
lua_State *ls;
int i;

	w=(WORLD *)p->w;
	ene=(ENEMY *)p->ene;
	data=(DATA *)p->data;
	gfx=(GFX *)p->gfx;
	ls=(lua_State *)p->ls;
	sw=(SWITCH *)p->sw;
	energy=(ENERGY *)p->energy;
	plat=(PLATFORM *)p->plat;
	ene->actenemy=0;
	energy->actenergy=0;
	sw->actswitch=0;
	plat->actplatform=0;
	
	for (i=0;i<MAX_ENEMIES;i++) ene->active[i]=0;
	for (i=0;i<MAXENERGY;i++) energy->active[i]=0;
	for (i=0;i<MAXSWITCHES;i++) sw->active[i]=0;
	for (i=0;i<MAXPLATFORMS;i++) plat->active[i]=0;
	w->visited_rooms[room]=1;
	lua_getglobal(ls,"set_world_data");
	lua_pushnumber(ls,80);
	lua_pushnumber(ls,76);
	lua_pushnumber(ls,room);
	lua_pushlightuserdata(ls,w);
	lua_pushlightuserdata(ls,ene);
	lua_pushlightuserdata(ls,data);
	lua_pushlightuserdata(ls,gfx);
	lua_pushlightuserdata(ls,energy);
	lua_pushlightuserdata(ls,sw);
	lua_pushlightuserdata(ls,plat);
	lua_pcall(ls,10,0,0);
	ph_remove_bloodspot(p->bs);
}


PROGRAM * ph_game_over(PROGRAM *p)
{
int i=0;
int totalvrooms=0;
signed int score=0;
//PHTTP *web;
BITMAP *bmp, *bmp1=NULL;
//int gani=0;

	ph_do_speccy(p);
	p->t->acycle=p->t->target_cycle=0;
	bmp=create_bitmap(640,480);
	bmp1=create_bitmap(640,480);
	clear_to_color(bmp1,makecol(200,200,200));
	blit(screen,bmp,0,0,0,0,640,480);
	p->t->acycle=p->t->target_cycle=0;
	/*
	while(!key[KEY_ESC])
	{
		while(p->t->target_cycle>p->t->acycle)
		{
			gani++;
			if (gani>=2) gani=0;
		}
		switch(gani)
		{
			case 0:
				rectfill(screen,0,0,640,480,makecol(rand()%255,rand()%255,rand()%255));
				break;
			case 1:
				blit(bmp,screen,0,0,0,0,640,480);
				break;
		}
	}*/
	destroy_bitmap(bmp);
	destroy_bitmap(bmp1);
		
	ph_fade_out(16,p->gfx,p->cfg,p->snd);
	clear_keybuf();
	#if HAVE_ALDUMB_H
		if (p->cfg->music && p->cfg->enable_sound)
		al_poll_duh(p->snd->music->mpl);
	#endif
	
	for (i=0;i<MAXWORLDROOMS;i++)
	{
		if (p->w->visited_rooms[i])
		{
			totalvrooms++;
		}
	}
	rectfill(p->gfx->virt[0],0,0,p->gfx->virt[0]->w,p->gfx->virt[0]->h,makecol(0,0,0));
	draw_sprite(p->gfx->virt[0],p->gfx->gameover,240-(p->gfx->gameover->w>>1),70);
	ph_set_text_properties(p->fnt,makecol(120,120,120),-1,TXT_TITLE,TXT_CENTER,15,0,1);
	ph_printf(p->gfx->virt[0],p->fnt,320-80,150,_("You have visited %d rooms."),totalvrooms);
	ph_printf(p->gfx->virt[0],p->fnt,320-80,180,_("You have pressed %d switches."),p->pl->pressed_switches);
	score=((totalvrooms+p->pl->pressed_switches)*100)/136;
	score=totalvrooms+p->pl->pressed_switches;
	if (p->pl->treasure) score+=1;
	if (p->pl->safe) score+=1;
	if (p->pl->cheats) score=-100;
	if (p->pl->cheats) score=-100;
	ph_printf(p->gfx->virt[0],p->fnt,320-80,210,_("Your score: %d of a maximum of 100 points."),score);
	p->fnt->color=makecol(255,255,255);
	ph_printf(p->gfx->virt[0],p->fnt,318-80,149,_("You have visited %d rooms."),totalvrooms);
	ph_printf(p->gfx->virt[0],p->fnt,318-80,179,_("You have pressed %d switches."),p->pl->pressed_switches);
	ph_printf(p->gfx->virt[0],p->fnt,318-80,209,_("Your score: %d of a maximum of 100 points."),score);
	if (score<0) ph_printf(p->gfx->virt[0],p->fnt,318-80,225,_("This is the result of being a cheater :-P"));

	p->fnt->color=makecol(255,255,0);
	#if !GP2X
		ph_text(p->gfx->virt[0],p->fnt,320-80,240,_("Press Enter to continue..."));
	#else
		ph_text(p->gfx->virt[0],p->fnt,320-80,240,_("Press X to continue..."));
	#endif
	p->fnt->align=TXT_LEFT;
	
	if (p->cfg->stretch)
	{
		stretch_blit(p->gfx->virt[0],screen,0,0,p->gfx->virt[0]->w,p->gfx->virt[0]->h,0,0,p->cfg->stretchx,p->cfg->stretchy);
	}
	else
	{
		blit(p->gfx->virt[0],screen,0,0,0,0,p->cfg->xres,p->cfg->yres);
	}
	/*
	#if !GP2X
		blit(p->gfx->virt[0],screen,0,0,80,76,640,480);
	#else
		stretch_blit(p->gfx->virt[0],screen,0,0,p->gfx->virt[0]->w,p->gfx->virt[0]->h,80,76,320,240);
	#endif
	*/
	/******************************************
	PRUEBA DE RECIBIR DATOS
	******************************************/
	#if !GP2X
		lua_dofile(p->ls,ph_get_path(p->cfg,p->path,"scripts/network.bin"));
	#endif
	
	while(!key[KEY_ENTER])
	{	
		#if HAVE_ALDUMB_H
			if (p->cfg->music && p->cfg->enable_sound)
			al_poll_duh(p->snd->music->mpl);
		#endif
		#if GP2X
			poll_joystick();
			if (joy[0].button[1].b) break;
		#endif
	}
	#if !GP2X
		clear_keybuf();
	#endif
	ph_show_records(p);
	memset(p->pl,0,sizeof(struct PLAYER));
	memset(p->v,0,sizeof(struct VEHICLE));
	p->cfg->autoframeskip=1;
	p->pl->x=itofix(64);
	p->pl->y=itofix(16);
	p->b->x=0;
	p->b->y=128;
	p->pl->right=1;
	p->pl->aniframe=1;
	p->pl->speed=4;
	p->pl->jumping=0;
	p->pl->energy=238;
	p->pl->end=0;
	p->pl->treasure=0;
	p->pl->safe=0;
	p->pl->rocket=0;
	p->pl->inchopper=0;
	p->pl->inrocket=0;
	p->pl->pressed_switches=0;
	p->w->actroom=0;
	
	p->w=ph_load_world_data_alt(p->w,p->data);
	p->b->active=0;
	p->pl->inball=0;
	p->pl->ballspeed=248;
	
	blit(p->gfx->virt[2],screen,0,0,64,76,16,288);
	blit(p->gfx->virt[3],screen,0,0,560,76,16,288);
	blit(p->gfx->virt[4],screen,0,0,64,60,512,16);
	blit(p->gfx->virt[5],screen,0,0,64,364,512,16);
	
	ph_remove_bloodspot(p->bs);
	
	
	for (i=0;i<100;i++) 
	{
		p->energy->got[i]=0;
		p->sw->pressed[i]=0;
		p->sw->switchid[i]=0;
	}
	memset(p->v,0,sizeof(struct VEHICLE));
	memset(p->w->visited_rooms,0,sizeof(char)*MAXWORLDROOMS);
	memset(p->ar,0,sizeof(struct ARROWS));
	memset(p->bl,0,sizeof(struct BLOCK));
	memset(p->b,0,sizeof(struct BALL));
	p->bl->x=176;
	p->bl->y=32;
	p->sw->actswitch=0;
	ph_get_room_data(p->w,p->w->actroom,p->pl);
	ph_change_room(p,p->w->actroom);
	set_trans_blender(127,127,127,127);
	clear_to_color(p->gfx->virt[0],makecol(0,0,0));
	
	if (p->cfg->stretch)
	{
		stretch_blit(p->data->dgfx[PHANTGFX_DAT_MISFONDO_BMP].dat,screen,0,0,p->cfg->xres,p->cfg->yres,0,0,p->cfg->stretchx,p->cfg->stretchy);
	}
	else
	{
		blit(p->data->dgfx[PHANTGFX_DAT_MISFONDO_BMP].dat,screen,0,0,0,0,p->cfg->xres,p->cfg->yres);
	}
	p->b->y=128;

	return p;
}

void ph_fade_out(int speed, GFX *gfx, CFG *cfg, SOUND *snd)
{
BITMAP *bmp_orig=NULL;
BITMAP *bmp_buff=NULL;

	if ((bmp_orig = create_bitmap(640, 480)))
	{
		if ((bmp_buff = create_bitmap(640, 480)))
		{
			int a;
			
			blit(screen, bmp_orig, 0,0, 0,0, 640, 480);
			//blit(screen, bmp_orig, 80,76, 0,0, 480, 288);
			if (speed <= 0) speed = 16;
			
			for (a = 255-speed; a > 0; a-=speed)
			{
		#if HAVE_ALDUMB_H
			if (cfg->music && cfg->enable_sound)
			al_poll_duh(snd->music->mpl);
		#endif
				clear(bmp_buff);
				set_trans_blender(0,0,0,a);
				draw_trans_sprite(bmp_buff, bmp_orig, 0, 0);
				vsync();
			
				if (cfg->stretch)
				{
//					stretch_blit(bmp_buff,screen,0,0,bmp_buff->w,bmp_buff->h,0,0,cfg->stretchx,cfg->stretchy);
					blit(bmp_buff,screen,0,0,0,0,cfg->xres,cfg->yres);
				}
				else
				{
					blit(bmp_buff,screen,0,0,0,0,cfg->xres,cfg->yres);
				}
			}
		}
	}

	set_trans_blender(255,255,255,255);
	rectfill(bmp_buff, 0,0, 480,288, makecol(0,0,0));
	vsync();
	blit(bmp_buff, screen, 0,0, 80,76, 480, 288);
	destroy_bitmap(bmp_buff);
	destroy_bitmap(bmp_orig);
}



void ph_in_game_message(CONTROL *c, GFX *gfx, DATA *data, CFG *cfg, SOUND *sound, PLAYER *pl, PHFONT *fnt, char event)
{
	set_trans_blender(200,200,200,200);
	drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
	rectfill(gfx->virt[0],0,81,479,219,makecol(0,0,50));
	draw_sprite(gfx->virt[0],gfx->face,20,110);
	set_trans_blender(255,255,255,255);
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

	#if HAVE_ALDUMB_H
		if (cfg->music && cfg->enable_sound)
		al_poll_duh(sound->music->mpl);
	#endif
	
	ph_set_text_properties(fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,13,0,1);

	switch(event)
	{
		case 0:
			ph_text(gfx->virt[0],fnt,111,100,_("I'm already here."));
			if (c->type==0)
			{
				ph_printf(gfx->virt[0],fnt,111,120,_("You can move me with the keys %c,%c,%c,%c"),c->key[0],c->key[1],c->key[2],c->key[3]);
			}
			else
			{
				ph_text(gfx->virt[0],fnt,111,120,_("You can move me with the joystick"));
			}
			
			ph_text(gfx->virt[0],fnt,111,140,_("and I have 2 kinds of jumps: long and high."));
			ph_text(gfx->virt[0],fnt,111,160,_("Don't touch the enemies,"));
			ph_text(gfx->virt[0],fnt,111,180,_("I have no weapons!"));
			break;
		case 1:
			ph_text(gfx->virt[0],fnt,111,100,_("Argh, I've been hit."));
			ph_text(gfx->virt[0],fnt,111,120,_("Look at the bar below and to the right,"));
			ph_text(gfx->virt[0],fnt,111,140,_("this is the energy bar, when the enemies hit me"));
			ph_text(gfx->virt[0],fnt,111,160,_("it gets darker, when it gets totally dark,"));
			ph_text(gfx->virt[0],fnt,111,180,_("I will die, you have been warned!"));
			break;
		case 2:
			ph_text(gfx->virt[0],fnt,111,100,_("Energy capsules make me feel better,"));
			ph_text(gfx->virt[0],fnt,111,120,_("but don't count on getting many of them."));
			ph_text(gfx->virt[0],fnt,111,140,_("There are only a few."));
			break;
		case 3:
			ph_text(gfx->virt[0],fnt,111,100,_("Hey, I know this type of switch!"));
			ph_text(gfx->virt[0],fnt,111,120,_("It guards the safe."));
			ph_text(gfx->virt[0],fnt,111,140,_("I have to push all of them or the"));
			ph_text(gfx->virt[0],fnt,111,160,_("safe won't open!"));
			break;
		case 4:
			ph_text(gfx->virt[0],fnt,111,100,_("Amazing! We have pressed every switch!"));
			ph_text(gfx->virt[0],fnt,111,120,_("Now let's go for the safe!"));
			ph_text(gfx->virt[0],fnt,111,140,_("It should be in Goldter's office."));
			break;
		case 5:
			ph_text(gfx->virt[0],fnt,111,100,_("Great! We got the safe!!"));
			if (!pl->treasure)
			{
				ph_text(gfx->virt[0],fnt,111,120,_("We should go for the treasure now!"));
				ph_text(gfx->virt[0],fnt,111,140,_("Surely it is in the gauntlet."));
			}
			else
			{
				ph_text(gfx->virt[0],fnt,111,120,_("Let's run to the exit!"));
			}
			break;
		case 7:
			ph_text(gfx->virt[0],fnt,111,100,_("It's a trap!!!"));
			ph_text(gfx->virt[0],fnt,111,120,_("Press V-B alternatively to run!!"));
			break;
	}
	ph_draw(gfx,cfg);
	
	#if !GP2X
		clear_keybuf();
	#endif
	
	while(!key[KEY_ENTER])
	{
		#if HAVE_ALDUMB_H
			if (cfg->music && cfg->enable_sound)
			al_poll_duh(sound->music->mpl);
		#endif
		#if GP2X
			poll_joystick();
			if (joy[0].button[1].b) break;
		#endif
	}
	set_trans_blender(127,127,127,127);

	if (event==7)
	{
		do_ball_trap(c,gfx,data,cfg,sound,pl);
	}
}


char ph_special_cases(PROGRAM *p)
{
char res=0;
	
	switch(p->w->actroom)
	{
		case 2:
/*			if (fixtoi(p->pl->x)==216 && fixtoi(p->pl->y)==144 && !p->pl->inchopper)
			{
				p->pl->inchopper=1;
				res=ph_anim_chopper(p,0);
			}*/
			break;
/*		case 65:
			if (fixtoi(p->pl->x)==420 && fixtoi(p->pl->y)==224)
			{
				p->pl->inchopper=1;
				res=ph_anim_chopper(p,1);
			}*/
		/*
		case 5:
			if (fixtoi(p->pl->x)==208 && fixtoi(p->pl->y)==128 && !p->pl->inrocket)
			{
				p->pl->inrocket=1;
				res=ph_anim_rocket(p,0);
			}
			break;*/
	/*	case 64:
			// Hacer aqui lo de la bola
			if (fixtoi(p->pl->x)==96)
			{
			
			}
			break;*/
		/*
		case 66:
			if (fixtoi(p->pl->x)==208 && fixtoi(p->pl->y)==144)
			{
				p->pl->inrocket=1;
				res=ph_anim_rocket(p,1);
			}
			break;*/
	}
	return res;
}


char ph_anim_rocket(PROGRAM *p,char animtype)
{
BITMAP *bmp;
int yrocket=114;
int hrocket;
int i,a;


	p->pl->astro=1;
	bmp=create_bitmap(p->gfx->virt[0]->w,p->gfx->virt[0]->h);
	
	hrocket=p->gfx->decspr[PHANTGFX_DAT_DEC42_0_BMP-6]->h;
	
	while(yrocket>0-hrocket-10)
	{
		ph_draw_dec(p);
		ph_draw_switch(p->sw,p->gfx);
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC42_0_BMP-6],176,yrocket);
		ph_draw(p->gfx,p->cfg);
		yrocket-=2;
		ph_read_common_keys(p,p->c,p->menu,p->fnt);
		#if HAVE_ALDUMB_H
			if (p->cfg->music && p->cfg->enable_sound)
			al_poll_duh(p->snd->music->mpl);
		#endif
		rest(100);
	}
	
	if (!animtype) p->w->actroom=66; else p->w->actroom=5;
	ph_change_room(p,p->w->actroom);
	ph_get_room_data(p->w,p->w->actroom,p->pl);
	
	while(yrocket<114)
	{
		ph_draw_dec(p);
		ph_draw_switch(p->sw,p->gfx);
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC42_0_BMP-6],176,yrocket);
		ph_draw(p->gfx,p->cfg);
		yrocket+=2;
		ph_read_common_keys(p,p->c,p->menu,p->fnt);
		
		#if HAVE_ALDUMB_H
			if (p->cfg->music && p->cfg->enable_sound)
			al_poll_duh(p->snd->music->mpl);
		#endif
		rest(100);
	}
	
	destroy_bitmap(bmp);
	if (p->w->actroom==66) 
	{
		ph_play_sample(p->snd->sfx->hjump,fixtoi(p->pl->x),p->cfg);
		p->pl->jumping=1;
		p->pl->right=1;
	}
	else
	{
		p->pl->jumping=0;
		p->pl->astro=0;
	}
	
	/* Al cambiar el grafico del cohete, hay que cambiar las zonas duras,
	aunque sea a lo bestia ;-), esto solo borra las zonas duras, en teoria
	deberia poner las nuevas pero si lo pongo no se puede ir a las pantallas
	anteriores con lo que creo que se perjudica la jugabilidad. */
	for (a=0;a<4;a++)
	{
		for (i=0;i<7;i++) p->w->crossdata[2982+i+(a*30)]=0;
	}
	
	p->t->acycle=p->t->target_cycle=0;
	return 1;
}


void ph_draw_dec(PROGRAM *p)
{
int i,a;
static int x=0;
	ph_draw_back_image(p->w,p->gfx);
	
	if (p->w->actroom!=67)
	{
		for (a=0;a<YMAXTILE;a++)
		{
			for (i=0;i<XMAXTILE;i++)
			{
				if (p->w->room[i][a]!=32) draw_sprite(p->gfx->virt[0],p->gfx->decspr[(int)p->w->room[i][a]],(i<<4),(a<<4));
				else 
				{
					set_trans_blender(127,127,127,127);
					draw_sprite(p->gfx->virt[0],p->gfx->decspr[(int)p->w->room[i][a]],(i<<4),(a<<4));
					set_trans_blender(255,255,255,255);
				}
			}
		}
	}
	else
	{
		for (i=0;i<960;i+=32)
		{
			draw_sprite(p->gfx->virt[0],p->data->dgfx[PHANTGFX_DAT_DEC64_0_BMP].dat,i+x,256);
		}
		x-=4;
		if (x<=-480) x=0;
	}
	/*
	if ((p->w->actroom==5 && p->pl->inrocket) || (p->w->actroom==66 && p->pl->inrocket))
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC42_0_BMP-6],176,114);
	}
	*/
	
	
	if (p->w->actroom==5 && !p->pl->inrocket && p->v->ractive<5)
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC06_0_BMP-MAXSPRBACK],176+16,114+32);
	}
	
	if (p->w->actroom==5 && p->v->ractive>=2)
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC04_0_BMP-MAXSPRBACK],176+32,112);
	}
				
	if (p->w->actroom==7)
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[(PHANTGFX_DAT_DECO111_0_BMP-MAXSPRBACK)+rand()%7],368,48);
	
	}
	if (p->w->actroom==57 && !p->pl->opendoor)
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC81_0_BMP-MAXSPRBACK],0,96);
	}
	if (p->w->actroom==57 && p->pl->explotedoor==2 && fixtoi(p->pl->x)>=32)
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC81_0_BMP-MAXSPRBACK],0,96);
	}
	if (p->w->actroom==56 && p->pl->treasure && !p->pl->explotedoor)
	{
		draw_sprite(p->gfx->virt[0],p->gfx->decspr[PHANTGFX_DAT_DEC81_0_BMP-MAXSPRBACK],448,96);
	}
	
}





PROGRAM * ph_load_game(PROGRAM *p)
{
PACKFILE *file;

	
	file=pack_fopen("phantomas.sav",F_READ);
	if (!file)
	{
		ph_log(_("Error: I can't load the game!\n"));
	}
	else
	{
		pack_fread(p,sizeof(struct PROGRAM),file);
		pack_fclose(file);
	}
	return p;
}


char ph_save(PROGRAM *p)
{
PACKFILE *file;

	file=pack_fopen("phantomas.sav",F_WRITE);
	if (!file)
	{
		ph_log(_("Error: I can't save the game!\n"));
		return 0;
	}
	else
	{
		pack_fwrite(p,sizeof(struct PROGRAM),file);
		pack_fclose(file);
		return 1;
	}

}


void ph_game_end(PROGRAM *p)
{
static signed int y=300;
static char view=0;

	ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,18,0,1);
	
	if (!p->pl->cheats)
	{
		if (!view)
		{
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,20,80,_("A small nuisance that won't stop us"));
			ph_printf(p->gfx->virt[0],p->fnt,20,110,_("from having more adventures from"));
			ph_printf(p->gfx->virt[0],p->fnt,20,140,_("PHANTOMAS..."));
			ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,78,_("A small nuisance that won't stop us"));
			ph_printf(p->gfx->virt[0],p->fnt,18,108,_("from having more adventures from"));
			ph_printf(p->gfx->virt[0],p->fnt,18,138,_("PHANTOMAS..."));
			if (key[KEY_ESC] || key[KEY_ENTER])
			{
				view=1;
			}
		}
		if (view) 
		{
			y--;
			if (y<=-1000) 
			{
				y=300;
				view=2;
			}
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+2,_("Phantomas PC, a remake of Phantomas"));
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+30+2,_("Original game developed by Enric Cervera."));
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+160+2,_("Phantomas PC team"));
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+190+2,_("Graphics by Na_th_an"));
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+220+2,_("Music by Addax"));
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+250+2,_("Program by Traperic"));
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+380+2,_("Thanks to:"));
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+410+2,_("David Gonzalez"));
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+440+2,_("Popolon"));
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+470+2,_("The best Spanish remakes site:"));
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+500+2,_("http://www.remakeszone.com"));
			ph_set_text_properties(p->fnt,makecol(20,20,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18+2,y+900+2,_("This is the END... at the moment..."));
		
			ph_set_text_properties(p->fnt,makecol(250,250,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y,_("Phantomas PC, a remake of Phantomas"));
			ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y+30,_("Original game developed by Enric Cervera."));
			ph_set_text_properties(p->fnt,makecol(250,250,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y+160,_("Phantomas PC team"));
			ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y+190,_("Graphics by Na_th_an"));
			ph_printf(p->gfx->virt[0],p->fnt,18,y+220,_("Music by Addax"));
			ph_printf(p->gfx->virt[0],p->fnt,18,y+250,_("Program by Traperic"));
			ph_set_text_properties(p->fnt,makecol(250,250,20),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y+380,_("Thanks to:"));
			ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y+410,_("David Gonzalez"));
			ph_printf(p->gfx->virt[0],p->fnt,18,y+440,_("Popolon"));
			ph_printf(p->gfx->virt[0],p->fnt,18,y+470,_("The best Spanish remakes site:"));
			ph_printf(p->gfx->virt[0],p->fnt,18,y+500,_("http://www.remakeszone.com"));
			ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_LEFT,18,0,1);
			ph_printf(p->gfx->virt[0],p->fnt,18,y+900,_("This is the END... at the moment..."));
			if (key[KEY_ESC] || key[KEY_ENTER])
			{
				if (view==2)
				{
					view=0;
					p->pl->y=itofix(16);
					ph_game_over(p);
				}
			}
		}
	}
	
	p->pl->endframe++;
}


void ph_show_credits(PROGRAM *p)
{
}

/* FIXME Corregirlo para que utilice las coordenadas desde CFG */
void ph_do_speccy(PROGRAM *p)
{
char a=0;
char anim=0;
int spcol[8];
char i=0;


	spcol[0]=makecol(0,0,0);
	spcol[1]=makecol(192,0,0);
	spcol[2]=makecol(0,192,0);
	spcol[3]=makecol(0,0,192);
	spcol[4]=makecol(192,192,0);
	spcol[5]=makecol(192,0,192);
	spcol[6]=makecol(0,192,192);
	spcol[7]=makecol(192,192,192);
	for (i=0;i<3;i++)
	{
		anim=0;
		while(anim<15)
		{
		#if HAVE_ALDUMB_H
			if (p->cfg->music && p->cfg->enable_sound)
			al_poll_duh(p->snd->music->mpl);
		#endif

			if (!(anim%2))
			{
				draw_sprite(screen,p->gfx->virt[0],80,76);
			}
			else
			{
				rectfill(screen,80,76,480+79,288+75,spcol[(int)a]);
				a++;
				if (a==8) a=0;
			}
			anim++;
			rest(20);
		}
	}
	
}
