#include "help.h"
#include "trans.h"
#include "data.h"
#include "phantom1.h"

void ph_show_help(PROGRAM *p)
{
static char page=0;
BITMAP *bmp=NULL;

	bmp=create_bitmap(p->gfx->virt[0]->w,p->gfx->virt[0]->h);
	clear_to_color(bmp,makecol(0,0,0));
	blit(p->gfx->virt[0],bmp,0,0,0,0,bmp->w,bmp->h);
	clear_keybuf();
	ph_show_help_page(p,page);
	
	while(!key[KEY_ESC])
	{
		#if HAVE_ALDUMB_H
			if (p->cfg->music && p->cfg->enable_sound)
			al_poll_duh(p->snd->music->mpl);
		#endif
		
		if ((key[KEY_LEFT] && page>0) || (key[KEY_PGUP] && page>0))
		{
			page--;
			draw_sprite(p->gfx->virt[0],bmp,0,0);
			ph_show_help_page(p,page);
		}
		if ((key[KEY_RIGHT] && page<4) || (key[KEY_PGDN] && page<4))
		{
			page++;
			draw_sprite(p->gfx->virt[0],bmp,0,0);
			ph_show_help_page(p,page);
		}
		rest(100);
	}
	clear_keybuf();
	p->t->acycle=p->t->target_cycle=0;
	destroy_bitmap(bmp);
}


void ph_show_help_page(PROGRAM *p, char page)
{
	set_trans_blender(200,200,200,200);
	drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
	rectfill(p->gfx->virt[0],0,81,479,249,makecol(0,0,50));
	set_trans_blender(255,255,255,255);
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
	draw_sprite(p->gfx->virt[0],p->gfx->smalllogo,(480>>1)-(p->gfx->smalllogo->w>>1),20);
	ph_set_text_properties(p->fnt,makecol(255,255,0),-1,TXT_TITLE,TXT_CENTER,20,0,1);
	
	switch(page)
	{
		case 0:
			ph_shprintf(p->gfx->virt[0],p->fnt,240,80,_("Instructions %d/3"),page+1);
		break;
		case 1:
			ph_shprintf(p->gfx->virt[0],p->fnt,240,80,_("Instructions %d/3"),page+1);
		break;
		case 2:
			ph_shprintf(p->gfx->virt[0],p->fnt,240,80,_("Instructions %d/3"),page+1);
		break;
		case 3:
			ph_shprintf(p->gfx->virt[0],p->fnt,240,80,_("Keyboard shortcuts %d/2"),page/3);
		break;
		case 4:
			ph_shprintf(p->gfx->virt[0],p->fnt,240,80,_("Keyboard shortcuts %d/2"),(page/3)+1);
		break;

		
	}
	ph_set_text_properties(p->fnt,makecol(255,255,255),-1,TXT_TITLE,TXT_CENTER,13,0,1);
		
	switch(page)
	{
		case 0:
			draw_sprite(p->gfx->virt[0],p->gfx->swspr[0],230,125);
			draw_sprite(p->gfx->virt[0],p->gfx->decspr[22],230,160);
			draw_sprite(p->gfx->virt[0],p->gfx->decspr[80],230,200);
			ph_shprintf(p->gfx->virt[0],p->fnt,240,105,_("First of all, you have to press all the switches!."));
			ph_shprintf(p->gfx->virt[0],p->fnt,240,145,_("When done, go for the safe."));
			ph_shprintf(p->gfx->virt[0],p->fnt,240,192,_("After that, take the treasure!"));
			ph_shprintf(p->gfx->virt[0],p->fnt,240,232,_("And then run to the exit!!!... sounds easy, doesn't it?"));
			
		break;
		case 1:
			draw_sprite(p->gfx->virt[0],(BITMAP *)p->data->dgfx[PHANTGFX_DAT_ENE13_0_0_BMP].dat,225,165);
			ph_text(p->gfx->virt[0],p->fnt,240,105,_("Unfortunately, there are some 'things' that won't let"));
			ph_printf(p->gfx->virt[0],p->fnt,240,125,_("your journey to be a pleasant trip."));
			ph_printf(p->gfx->virt[0],p->fnt,240,145,_("Like this for example, say hello to Peposo beard."));
			ph_printf(p->gfx->virt[0],p->fnt,240,200,_("Don't trust him with that angelical face!"));
			ph_printf(p->gfx->virt[0],p->fnt,240,220,_("He and the others will drain your energy at the moment you touch them!"));
		break;
		case 2:
			draw_sprite(p->gfx->virt[0],p->gfx->lifespr[0],225,125);
			ph_text(p->gfx->virt[0],p->fnt,240,105,_("You can use the energy capsules to recover some energy."));
			ph_text(p->gfx->virt[0],p->fnt,240,145,_("And use your high and long jump to avoid enemies."));
			ph_text(p->gfx->virt[0],p->fnt,240,165,_("This is all you have to know to play. Good luck!"));
		break;
		case 3:
			ph_text(p->gfx->virt[0],p->fnt,240,105,_("F1: Show the help screen."));
			ph_text(p->gfx->virt[0],p->fnt,240,125,_("F2: Sound menu."));
			ph_text(p->gfx->virt[0],p->fnt,240,145,_("F3: Redefine keys."));
			ph_text(p->gfx->virt[0],p->fnt,240,165,_("F10: Abort the game."));
			ph_text(p->gfx->virt[0],p->fnt,240,185,_("F12: Take a screenshot."));
			ph_text(p->gfx->virt[0],p->fnt,240,205,_("ESC: Show/hide the menu. / Hide the text boxes."));
			ph_text(p->gfx->virt[0],p->fnt,240,225,_("Alt+Enter: Switch to fullscreen / windowed mode."));
		break;
		case 4:
			ph_text(p->gfx->virt[0],p->fnt,240,105,_("Alt+F4: Quit the game."));
			ph_text(p->gfx->virt[0],p->fnt,240,125,_("Control+Q: Quit the game."));
		break;
	}
	
	ph_draw(p->gfx,p->cfg);
}

