/*
	Header file for blood.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#ifndef __BLOOD_H
#define __BLOOD_H

#include "gfx.h"

#define MAXBLOODSPOTS 500

typedef struct BLOODSPOT
{
	signed short int dir[MAXBLOODSPOTS];
	signed short int x[MAXBLOODSPOTS];
	signed short int y[MAXBLOODSPOTS];
	signed short int xspeed[MAXBLOODSPOTS];
	signed short int yspeed[MAXBLOODSPOTS];
	signed short int duration[MAXBLOODSPOTS];
	unsigned char active[MAXBLOODSPOTS];
	unsigned short int actbspot;
} BLOODSPOT;


BLOODSPOT * ph_init_bloodspot(void);
void ph_destroy_bloodspot(BLOODSPOT *bs);
void ph_create_bloodspot(BLOODSPOT *bs, unsigned char amount, signed short int x, signed short int y);
void ph_move_bloodspot(BLOODSPOT *bs, GFX *gfx);
void ph_remove_bloodspot(BLOODSPOT *bs);
void ph_draw_blood(BLOODSPOT *bs, GFX *gfx);


#endif
