/*
*/


#ifndef __CFG_H
#define __CFG_H

#ifdef __cplusplus
extern "C"
{
#endif

	#include <lua.h>
	#include <lualib.h>
	#include <lauxlib.h>

#ifdef __cplusplus
}
#endif

#define DFLT_RESOLUTION 		0
#define DFLT_XRES		 		640
#define DFLT_YRES 				480
#define DFLT_FULLSCREEN 		1
#define DFLT_STRETCH			0
#define DFLT_STRETCHX			0
#define DFLT_STRETCHY			0
#define DFLT_ENABLE_SOUND		1
#define DFLT_SFX				1
#define DFLT_MUSIC				1
#define DFLT_SFXVOLUME			255
#define DFLT_MUSICVOLUME		255
#define DFLT_CONTROLTYPE		0
#define DFLT_CFGSCRIPT_PATH		"scripts/config.lua"
#define DFLT_CONFIG_FILE_W32	"phantpc.cfg"
#define DFLT_CONFIG_FILE_UNIX	".phantpc"
#define DFLT_DATADIR			"data/"
#define DFLT_PREFIX				"/usr/local/share/games/PhantomasPC/"
#define DFLT_KEY_UP				84
#define DFLT_KEY_DOWN			85
#define DFLT_KEY_LEFT			82
#define DFLT_KEY_RIGHT			83
#define GAME_NORMAL				0
#define GAME_CLASSIC			1
#define DFLT_GAME_TYPE			GAME_NORMAL
#define DFLT_SHOW_TIPS			1
#define DFLT_SCANLINES			0


typedef struct CFG
{
	unsigned char resolution;
	unsigned short int xres;
	unsigned short int yres;
	unsigned char fullscreen;
	unsigned char stretch;
	unsigned short int stretchx;
	unsigned short int stretchy;
	unsigned char enable_sound;
	unsigned char sfx;
	unsigned char music;
	unsigned char sfxvolume;
	unsigned char musicvolume;
	unsigned char controltype;
	unsigned char key_up;
	unsigned char key_down;
	unsigned char key_left;
	unsigned char key_right;
	unsigned char game_type;
	unsigned char show_tips;
	unsigned char autoframeskip;
	unsigned char scanlines;
	char *prefix;
	char *datadir;
} CFG;

typedef struct TEMPCFG
{
	unsigned char setup;
	unsigned char editor;
	unsigned char nosound;
	unsigned char nosfx;
	unsigned char nomusic;
	unsigned char joystick;
} TEMPCFG;

/**
 * 
 * @param ls 
 * @return 
 */
CFG * ph_init_configuration(unsigned char launch_setup,lua_State *ls);
TEMPCFG * ph_init_temp_configuration(void);
void ph_destroy_configuration(CFG *cfg);
void ph_destroy_temp_configuration(TEMPCFG *tcfg);
CFG * ph_set_config_defaults(CFG *cfg);
CFG *ph_get_config_from_script(CFG *cfg, lua_State *ls);
CFG * ph_get_config_from_cfg(CFG *cfg, lua_State *ls);
char ph_save_config_file(CFG *cfg);


#endif
