/*
	Header file for energy.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/

#ifndef __ENERGY_H
#define __ENERGY_H

#include "gfx.h"
#include "data.h"
#include "player.h"
#include "sfx.h"
#include "cfg.h"


#define MAXENERGY	10

typedef struct ENERGY
{
	signed short int x[MAXENERGY];
	signed short int y[MAXENERGY];
	char active[MAXENERGY];
	char actframe[MAXENERGY];
	char framespeed[MAXENERGY];
	char energyid[MAXENERGY];
	char got[100];
	char actenergy;
} ENERGY;


ENERGY * ph_init_energy(void);
void ph_destroy_energy(ENERGY *energy);
void ph_create_energy(ENERGY *energy, int x,int y, int actframe, int framespeed, char energyid);
void ph_draw_energy(ENERGY *energy, GFX *gfx);
void ph_get_energy(ENERGY *energy, PLAYER *pl, GFX *gfx, SOUND *snd, CFG *cfg);

#endif
