#ifndef __GFX_H
#define __GFX_H

#include <allegro.h>
#include "cfg.h"
#include "enemy2.h"

#define MAXVIRTSCREENS 7
#define MAXSPRDEC 127
#define MAXSPRPH 54
#define MAXSPRBACK 8
#define MAXSPRPLAT 20
#define MAXSPRPLIFE 4
#define MAXSPRSW 8

typedef struct GFX
{
	BITMAP *virt[MAXVIRTSCREENS];
	BITMAP *svirt;
	
	BITMAP *spr;
	BITMAP *backspr[MAXSPRBACK];
	/*! Sprites del enemigo */
	BITMAP *enespr[MAX_ENEMIES][4];
	/*! Sprites del decorado */
	BITMAP *decspr[MAXSPRDEC];
	/*! Sprites del protagonista */
	BITMAP *phspr[MAXSPRPH];
	/*! Sprites de las plataformas */
	BITMAP *plaspr[MAXSPRPLAT];
	BITMAP *lifespr[MAXSPRPLIFE];
	BITMAP *swspr[MAXSPRSW];
	BITMAP *gameover;
	BITMAP *borderup;
	BITMAP *borderdown;
	BITMAP *borderleft;
	BITMAP *borderright;
	BITMAP *face;
	BITMAP *logo;
	BITMAP *bigphan;
	BITMAP *smalllogo;
	BITMAP *energy;
	BITMAP *traperlogo[5];
	BITMAP *phhelper;
} GFX;

GFX * ph_init_gfx(CFG *cfg);
void ph_destroy_gfx(CFG *cfg, GFX *gfx);
void ph_draw(GFX *gfx, CFG *cfg);

#endif
