/*
	Lualleg 0.1 by Traperic <traperic@alamin.org>
	This is a very simple wrapper to use Allegro from a LUA script.
	See COPYING for copyright information.
	2005 Traperic Software.
*/
#ifndef __LUALLEG_H
#define __LUALLEG_H

#ifdef __cplusplus
extern "C"
{
#endif
	#include <lua.h>
	#include <lualib.h>
	#include <lauxlib.h>
#ifdef __cplusplus
}
#endif

#include <allegro.h>
#include <string.h>
#include "la_009.h"
#include "la_010.h"
#include "la_020.h"
#include "la_031.h"

#ifdef __cplusplus
extern "C" 
{
#endif

#define LASTRLEN 512


/*
 * Section: Lualleg functions.
 */
int la_get_allegro_def(lua_State *ls);
lua_State * la_register_lualleg_functions(lua_State *ls);

/* 
Section: Using Allegro
*/
int la_allegro_init(lua_State *ls);
int la_allegro_exit(lua_State *ls);
int la_get_allegro_id(lua_State  *ls);
int la_get_allegro_version(lua_State *ls);
int la_get_allegro_sub_version(lua_State *ls);
int la_get_allegro_wip_version(lua_State *ls);
int la_get_allegro_version_str(lua_State *ls);
int la_get_allegro_date_str(lua_State *ls);
int la_get_allegro_date(lua_State *ls);
int la_get_os_type(lua_State *ls);
int la_get_os_multitasking(lua_State *ls);
int la_allegro_message(lua_State *ls);
int la_set_window_title(lua_State *ls);
int la_desktop_color_depth(lua_State *ls);
int la_get_desktop_resolution(lua_State *ls);
int la_check_cpu(lua_State *ls);
int la_get_cpu_vendor(lua_State *ls);
int la_get_cpu_family(lua_State *ls);
int la_get_cpu_model(lua_State *ls);
int la_get_cpu_capabilities(lua_State *ls);

/*
Section: Structs and types used by Allegro 
*/
int la_get_bitmap_vars(lua_State *ls);
int la_get_rle_sprite_vars(lua_State *ls);
int la_get_compiled_sprite_vars(lua_State *ls);
int la_get_joystick_info_vars(lua_State *ls);
int la_get_joystick_button_info_vars(lua_State *ls);
int la_get_joystick_stick_info_vars(lua_State *ls);
int la_get_joystick_axis_info_vars(lua_State *ls);
int la_get_gfx_mode_list_vars(lua_State *ls);
int la_get_gfx_mode_vars(lua_State *ls);
int la_get_rgb_vars(lua_State *ls);
int la_get_v3d_vars(lua_State *ls);
int la_get_v3d_f_vars(lua_State *ls);
int la_get_al_ffblk_vars(lua_State *ls);
int la_get_datafile_vars(lua_State *ls);
int la_get_matrix_vars(lua_State *ls);

/*
Section: Unicode routines
*/ 
int la_set_uformat(lua_State *ls);

/*
Section: Mouse routines
*/
int la_install_mouse(lua_State *ls);
int la_remove_mouse(lua_State *ls);
int la_poll_mouse(lua_State *ls);
int la_mouse_needs_poll(lua_State *ls);
int la_enable_hardware_cursor(lua_State *ls);
int la_disable_hardware_cursor(lua_State *ls);
int la_select_mouse_cursor(lua_State *ls);
int la_set_mouse_cursor_bitmap(lua_State *ls);
int la_get_mouse_x(lua_State *ls);
int la_get_mouse_y(lua_State *ls);
int la_get_mouse_z(lua_State *ls);
int la_get_mouse_b(lua_State *ls);
int la_get_mouse_pos(lua_State *ls);
int la_get_mouse_sprite(lua_State *ls);
int la_get_mouse_x_focus(lua_State *ls);
int la_get_mouse_y_focus(lua_State *ls);
int la_show_mouse(lua_State *ls);
int la_scare_mouse(lua_State *ls);
int la_scare_mouse_area(lua_State *ls);
int la_unscare_mouse(lua_State *ls);
int la_get_freeze_mouse_flag(lua_State *ls);
int la_position_mouse(lua_State *ls);
int la_position_mouse_z(lua_State *ls);
int la_set_mouse_range(lua_State *ls);
int la_set_mouse_speed(lua_State *ls);
int la_set_mouse_sprite(lua_State *ls);
int la_set_mouse_sprite_focus(lua_State *ls);
int la_get_mouse_mickeys(lua_State *ls);


/*
Section: Timer routines
*/
int la_install_timer(lua_State *ls);
int la_remove_timer(lua_State *ls);
int la_get_retrace_count(lua_State *ls);
int la_rest(lua_State *ls);


/*
Section: Keyboard routines
*/
int la_install_keyboard(lua_State *ls);
int la_remove_keyboard(lua_State *ls);
int la_poll_keyboard(lua_State *ls);
int la_keyboard_needs_poll(lua_State *ls);
int la_get_key(lua_State *ls);
int la_get_key_shifts(lua_State *ls);
int la_keypressed(lua_State *ls);
int la_readkey(lua_State *ls);
int la_ureadkey(lua_State *ls);
int la_scancode_to_ascii(lua_State *ls);
int la_scancode_to_name(lua_State *ls);
int la_simulate_keypress(lua_State *ls);
int la_simulate_ukeypress(lua_State *ls);
int la_set_leds(lua_State *ls);
int la_clear_keybuf(lua_State *ls);


////////////////////////////
int la_set_color_depth(lua_State *ls);
int la_get_screen(lua_State *ls);
int la_get_font(lua_State *ls);
int la_get_gfx_mode(lua_State *ls);
int la_set_gfx_mode(lua_State *ls);
int la_get_screen(lua_State *ls);
int la_create_bitmap(lua_State *ls);
int la_clear_to_color(lua_State *ls);
int la_clear(lua_State *ls);
int la_destroy_bitmap(lua_State *ls);
int la_draw_sprite(lua_State *ls);
int la_draw_trans_sprite(lua_State *ls);
int la_rectfill(lua_State *ls);
int la_putpixel(lua_State *ls);
int la_drawing_mode(lua_State *ls);
int la_blit(lua_State *ls);
int la_text(lua_State *ls);
int la_makecol(lua_State *ls);
int la_acquire_screen(lua_State *ls);
int la_release_screen(lua_State *ls);
int la_textprintf_ex(lua_State *ls);
int la_vsync(lua_State *ls);
int la_load_sample(lua_State *ls);
int la_destroy_sample(lua_State *ls);
int la_play_sample(lua_State *ls);
int la_install_sound(lua_State *ls);

#ifdef __cplusplus
}
#endif
#endif
