#ifndef __PHTTP_H
#define __PHTTP_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if HAVE_CURL_H
	#include <curl/curl.h>
	#include <curl/types.h>
	#include <curl/easy.h>
#endif


#define MAXWEBBUFFER 50000
#define MAXSERVERNAME 1000
#define MAXFINALURL 2000


typedef struct PHTTP
{
	#if HAVE_CURL_H
		CURL *curl_handle;
	#endif
	char *server_name;
	char *final_url;
	char *buffer;
	char finished;
	size_t size;
} PHTTP;


PHTTP * ph_init_phttp(void);
void ph_destroy_phttp(PHTTP *p);
int ph_set_server_name(PHTTP *p, char *name);
int ph_set_url(PHTTP *p, char *name);
char * ph_get_web(PHTTP *p);
size_t ph_write_memory_cb(void *ptr, size_t size, size_t nmemb, void *data);
void * ph_my_realloc(void *ptr, size_t size);
int ph_obtain_web(void *me);

#endif
