/*
	Header file for player.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#ifndef __PLAYER_H
#define __PLAYER_H

#include <allegro.h>

typedef struct PLAYER
{
	fixed x;
	fixed y;
	fixed aniframe;
	char firsttimehit;
	char firsttimeenergy;
	char firsttimeswitch;
	signed char right;
	signed char speed;
	signed char falling;
	signed char jumping;
	signed char onplatform;
	signed short int energy;
	unsigned char pressed_switches;
	unsigned char visited_rooms;
	unsigned char opendoor;
	unsigned char explotedoor;
	unsigned char safe;
	unsigned char treasure;
	unsigned char points;
	unsigned char gametype;
	unsigned char showtips;
	unsigned char astro;
	unsigned char abu;
	unsigned char cheats;
	unsigned char damaging;
	signed int ballspeed;
	char rocket;
	char inrocket;
	char inchopper;
	char inball;
	char end;
	int endframe;
} PLAYER;


PLAYER * ph_init_player(void);
void ph_destroy_player(PLAYER *pl);


#endif
