#ifndef __SFX_H
#define __SFX_H

#include "config.h"

#include <allegro.h>
#include "cfg.h"
#include "gfx.h"
#include "texter.h"

#if HAVE_DUMB_H
	#include <dumb.h>
#endif

#if HAVE_ALDUMB_H
	#include <aldumb.h>
#endif

#if HAVE_ALOGG_H
	#include <alogg/alogg.h>
#endif

typedef struct SFX
{
	SAMPLE *hjump;
	SAMPLE *ljump;
	SAMPLE *push;
	SAMPLE *eat;
	SAMPLE *hit;
	SAMPLE *walk;
} SFX;


typedef struct MUSIC
{
#if HAVE_DUMB_H
	DUH *duh;
#endif

#if HAVE_ALDUMB_H
	AL_DUH_PLAYER *mpl;
#endif

#if HAVE_ALOGG_H
	SAMPLE *ogg;
	DATAFILE *dogg;
#endif

} MUSIC;


typedef struct SOUND
{
	SFX *sfx;
	MUSIC *music;
} SOUND;


SOUND * ph_init_sound(CFG *cfg);
void ph_destroy_sound(CFG *cfg, SOUND *sound);
SFX * ph_init_sfx();
MUSIC * ph_init_music();
void ph_play_sample(SAMPLE *sample, signed short int x, CFG *cfg);
void ph_set_volume(GFX *gfx, SOUND *snd, PHFONT *fnt, CFG *cfg);

#endif
