/*
	Header file for texter.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#ifndef __TEXTER_H
#define __TEXTER_H

#include <allegro.h>
#include <stdarg.h>
#include "config.h"

#if HAVE_ALFONT_H
	#include <alfont.h>
#endif

#define TXT_LEFT		0
#define TXT_CENTER		1
#define TXT_RIGHT		2
#define TXT_TITLE		3
#define TXT_UCODE		4

typedef struct PHFONT
{
	#if HAVE_ALFONT_H
		ALFONT_FONT *fnt;
		ALFONT_FONT *ufnt;
		void *d1;
		void *d2;
	#else
		FONT *fnt;
		FONT *ufnt;
	#endif
	signed int color;
	signed int back;
	unsigned char fonttype;
	unsigned char align;
	unsigned int size;
	char scalable;
	char aa;
} PHFONT;


PHFONT * ph_init_texter(void);
void ph_destroy_texter(PHFONT *pfont);
void ph_set_text_properties(PHFONT *pf, int color, int back, char fonttype, char align, unsigned int size, char scalable,char aa);
void ph_text(BITMAP *bmp, PHFONT *pf, signed short int x, signed short int y, char *buffer);
void ph_printf(BITMAP *bmp, PHFONT *pf, signed short int x, signed short int y, char *buf, ...);
void ph_shtext(BITMAP *bmp, PHFONT *pf, signed short int x, signed short int y, char *buffer);
void ph_shprintf(BITMAP *bmp, PHFONT *pf, signed short int x, signed short int y, char *buf, ...);
int ph_text_len(PHFONT *pfont, char *buffer);
char * ph_wrap_text(BITMAP *bmp, PHFONT *pf, char *txt, int xviewport, int yviewport);
char * ph_word_wrap(char *string, size_t line_len);
size_t ph_get_word(char *string); 
void ph_wrap_printf(BITMAP *bmp, PHFONT *pf, signed short int x, signed short int y, char *buf, ...);


#endif
