#ifndef __WORLD_H
#define __WORLD_H

#include "gfx.h"
#include "data.h"
#include "player.h"

#define XMAXTILE 30
#define YMAXTILE 18
#define MAXWORLDROOMS 69


typedef struct WORLD
{
	char room[XMAXTILE][YMAXTILE];
	char cross[XMAXTILE][YMAXTILE];
	unsigned char backdata;
	char *decdata;
	char *crossdata;
	unsigned char *enemydata;
	unsigned char *miscdata;
	unsigned char initroom;
	unsigned char actroom;
	signed short int wtriggers;
	signed short int xinit;
	signed short int yinit;
	char visited_rooms[MAXWORLDROOMS];

} WORLD;

WORLD * ph_init_world(void);
void ph_destroy_world(WORLD *w);
WORLD * ph_load_world_data(WORLD *w, CFG *cfg, char *path);
WORLD * ph_load_world_data_alt(WORLD *w, DATA *data);
void ph_save_world_data(WORLD *w, CFG *cfg, char *path);
void ph_get_room_data(WORLD *w, int room, PLAYER *pl);


#endif
