/*
	intro.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#include "intro.h"
#include "trans.h"
#include "control2.h"
#include "game.h"


/*!
 * Esta funcion se encarga de animar la pequena introduccion del juego.
 * @param p puntero con los datos del programa.
 */
void ph_do_intro(PROGRAM *p)
{
GFX *gfx;
CFG *cfg;
//int j=1;

#if HAVE_ALOGG_H
	char freq=0;
	int voice=0;
#endif
//int i=0,x,y,driver,olddriver;
int driver,olddriver;
	gfx=(GFX *)p->gfx;
	cfg=(CFG *)p->cfg;
	if (cfg->enable_sound && cfg->music)
	
	#if HAVE_ALOGG_H
		voice=play_sample(p->snd->music->ogg,255,127,1000,0);
	#endif
/*	
	while(1)
	{
		clear_to_color(gfx->virt[6],makecol(0,0,0));
		ph_set_text_properties(p->fnt,makecol(150,180,200),-1,TXT_TITLE,TXT_CENTER,18,0,1);
		ph_text(gfx->virt[6],p->fnt,320,340,_("Phantomas comes from a place very far away, in the Andromeda galaxy,"));
		ph_text(gfx->virt[6],p->fnt,320,360,_("He has been programmed exclusively to steal."));
		ph_text(gfx->virt[6],p->fnt,320,380,_("In the place of the cool thief, your mission is to steal a treasure"));
		ph_text(gfx->virt[6],p->fnt,320,400,_("hidden into a millonaire's mansion."));
		ph_text(gfx->virt[6],p->fnt,320,420,_("Good luck!"));
		for (i=0;i<200;i++)
		{
			x=rand()%640;
			y=rand()%240;
			y+=90;
			putpixel(gfx->virt[6],x,y,makecol(250,250,250));
		}
		draw_sprite(gfx->virt[6],gfx->bigphan,(320)-(gfx->bigphan->w/2),100);
		blit(gfx->virt[6],screen,0,0,0,0,640,480);
		if (key[KEY_ESC]) 
		{
			clear_keybuf();
			break;
		}	
		if (cfg->enable_sound && cfg->music)
		{
		#if HAVE_ALOGG_H
			if (voice_check(voice)==NULL) 
			{
				freq++;
				if (freq==4) freq=0;
				if (cfg->enable_sound && cfg->music)
					voice=play_sample(p->snd->music->ogg,255,128,1000+(50*freq),0);
			}
		#endif
		}
	}
	*/
	
	/* Dibujar presentacion Traperic Sofguar */
	/*while(!key[KEY_ESC])
	{
		clear_to_color(gfx->virt[6],makecol(0,0,0));
		draw_sprite(gfx->virt[6],gfx->eyes[j/6],100,100);
		blit(gfx->virt[6],screen,0,0,0,0,640,480);
		j++;
		if (j==36) j=1;
		
	}*/
	
	
	
	while(1)
	{
		clear_to_color(gfx->virt[6],makecol(30,40,40));
//		clear_to_color(gfx->virt[6],makecol(30,45,78));
		poll_joystick();
		if (joy[0].button[1].b)
		{
			break;
		}
		
		ph_read_common_keys(p,p->c,p->menu,p->fnt);
		ph_draw_menu(p->fnt,gfx,p->menu,p->m);
		
		ph_set_text_properties(p->fnt,makecol(0,0,0),-1,TXT_TITLE,TXT_CENTER,13,0,1);
		ph_text(gfx->virt[6],p->fnt,320,420,_("Original game by Enric Cervera. Copyright Dinamic 1986."));
		ph_text(gfx->virt[6],p->fnt,320,440,_("Program by Traperic Software. Graphics by Na_th_an and Traperic. Music by Addax."));
		ph_set_text_properties(p->fnt,makecol(250,250,250),-1,TXT_TITLE,TXT_CENTER,13,0,1);
		ph_text(gfx->virt[6],p->fnt,319,419,_("Original game by Enric Cervera. Copyright Dinamic 1986."));
		ph_text(gfx->virt[6],p->fnt,319,439,_("Program by Traperic Software. Graphics by Na_th_an and Traperic. Music by Addax."));
		if (p->cfg->stretch)
		{
			stretch_blit(p->gfx->virt[6],screen,0,0,p->gfx->virt[6]->w,p->gfx->virt[6]->h,0,0,p->cfg->stretchx,p->cfg->stretchy);
		}
		else
		{
			blit(gfx->virt[6],screen,0,0,0,0,640,480);
		}
		
		poll_joystick();
		
		if (key[KEY_ENTER] || joy[0].button[1].b)
		{
			if (p->menu->activemenu==MUSIC_MENU && p->menu->actelement<2)
			{
				if (p->menu->actelement) p->cfg->music=1; else p->cfg->music=0;
			}
			if (p->menu->activemenu==SFX_MENU && p->menu->actelement<2)
			{
				if (p->menu->actelement) p->cfg->sfx=1; else p->cfg->sfx=0;
			}
			if (p->menu->activemenu==SURROUND_MENU && p->menu->actelement<2)
			{
				//if (p->menu->actelement) p->cfg->surrond=1; else p->cfg->surrond=0;
				// FIXME 
			}
			if (p->menu->activemenu==MAIN_MENU && p->menu->actelement==0) break;
			if (p->menu->activemenu==MAIN_MENU && p->menu->actelement==3) break;
			if (p->menu->activemenu==CONTROLTYPE_MENU && p->menu->actelement==0)
			{
				p->c->type=CTRL_TYPE_KEYBOARD;
			}
			if (p->menu->activemenu==CONTROLTYPE_MENU && p->menu->actelement==1)
			{
				p->c->type=CTRL_TYPE_JOYSTICK;
			}
			if (p->menu->activemenu==RES_MENU && p->menu->actelement<4)
			{
				switch(p->menu->actelement)
				{
					case 0:
						p->cfg->stretch=1;
						p->cfg->stretchx=320;
						p->cfg->stretchy=240;
						break;
					case 1:
						p->cfg->stretch=0;
						p->cfg->stretchx=640;
						p->cfg->stretchy=480;
						break;
					case 2:
						p->cfg->stretch=1;
						p->cfg->stretchx=800;
						p->cfg->stretchy=600;
						break;
					case 3:
						p->cfg->stretch=1;
						p->cfg->stretchx=1024;
						p->cfg->stretchy=768;
						break;
				}
				
				if (p->cfg->fullscreen) {olddriver=driver=GFX_AUTODETECT;} else {olddriver=driver=GFX_AUTODETECT_WINDOWED;}
				ph_log(_("- Changing the graphic mode: "));
				
				if (!set_gfx_mode(driver,p->cfg->stretchx,p->cfg->stretchy,0,0))
				{
					ph_log(_("Ok.\n"));
				}
				else
				{
					ph_log(_("Error. Returning to previous graphic mode: "));
					if (set_gfx_mode(olddriver,p->cfg->xres,p->cfg->yres,0,0))
					{
						ph_log(_("Error, aborting program...\n"));
					}
					else
					{
						ph_log(_("Ok.\n"));
					}
				}
			}
			
			
			if (p->menu->activemenu==FULLSCREEN_MENU && p->menu->actelement==0)
			{
				p->cfg->fullscreen=1;
				if (p->cfg->fullscreen) {olddriver=driver=GFX_AUTODETECT;} else {olddriver=driver=GFX_AUTODETECT_WINDOWED;}
				ph_log(_("- Changing the graphic mode: "));
				
				if (!p->cfg->stretch)
				{
					if (!set_gfx_mode(driver,p->cfg->xres,p->cfg->yres,0,0))
					{
						ph_log(_("Ok.\n"));
					}
					else
					{
						ph_log(_("Error. Returning to previous graphic mode: "));
						if (set_gfx_mode(olddriver,p->cfg->xres,p->cfg->yres,0,0))
						{
							ph_log(_("Error, aborting program...\n"));
						}
						else
						{
							ph_log(_("Ok.\n"));
						}
					}
				}
				else
				{
					if (set_gfx_mode(driver,p->cfg->stretchx,p->cfg->stretchy,0,0))
					{
						set_gfx_mode(olddriver,p->cfg->stretchx,p->cfg->stretchy,0,0);
					}
				}
		
				if (olddriver==GFX_AUTODETECT_WINDOWED) set_window_title(_("Phantomas PC 0.8"));
			}
			if (p->menu->activemenu==FULLSCREEN_MENU && p->menu->actelement==1)
			{
				p->cfg->fullscreen=0;
				if (p->cfg->fullscreen) {olddriver=driver=GFX_AUTODETECT;} else {olddriver=driver=GFX_AUTODETECT_WINDOWED;}
				ph_log(_("- Changing the graphic mode: "));
				
				if (!p->cfg->stretch)
				{
					if (!set_gfx_mode(driver,p->cfg->xres,p->cfg->yres,0,0))
					{
						ph_log(_("Ok.\n"));
					}
					else
					{
						ph_log(_("Error. Returning to previous graphic mode: "));
						if (set_gfx_mode(olddriver,p->cfg->xres,p->cfg->yres,0,0))
						{
							ph_log(_("Error, aborting program...\n"));
						}
						else
						{
							ph_log(_("Ok.\n"));
						}
					}
				}
				else
				{
					if (set_gfx_mode(driver,p->cfg->stretchx,p->cfg->stretchy,0,0))
					{
						set_gfx_mode(olddriver,p->cfg->stretchx,p->cfg->stretchy,0,0);
					}
				}
				
				if (olddriver==GFX_AUTODETECT_WINDOWED) set_window_title(_("Phantomas PC 0.8"));
			}
		}
		
		if (cfg->enable_sound && cfg->music)
		{
		#if HAVE_ALOGG_H
			if (voice_check(voice)==NULL) 
			{
				freq++;
				if (freq==4) freq=0;
				if (cfg->enable_sound && cfg->music)
					voice=play_sample(p->snd->music->ogg,255,128,1000+(50*freq),0);
			}
		#endif
		}
	}
	
	
	if (cfg->enable_sound && cfg->music)
	#if HAVE_ALOGG_H
		voice_ramp_volume(voice,1500,0);
	#endif
	rest(1500);
	if (p->menu->actelement==0) ph_start_game(p);
	if (p->menu->actelement==3) ph_destroy_program(p);
}

