/*
	LuAlleg, wrapper to use Allegro under LUA.
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/

#include "la_009.h"


int la_acquire_bitmap(lua_State *ls)
{
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	acquire_bitmap(aux);
	return 0;
}


int la_acquire_screen(lua_State *ls)
{
	acquire_bitmap(screen);
	return 0;
}


int la_add_clip_rect(lua_State *ls)
{
BITMAP *aux;
int x1,x2,y1,y2;

	aux=(BITMAP *)lua_touserdata(ls,1);
	x1=(int)lua_tonumber(ls,2);
	y1=(int)lua_tonumber(ls,3);
	x2=(int)lua_tonumber(ls,4);
	y2=(int)lua_tonumber(ls,5);
	add_clip_rect(aux,x1,y1,x2,y2);
	return 0;
}


int la_bitmap_color_depth(lua_State *ls)
{
int res;
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=bitmap_color_depth(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_bitmap_mask_color(lua_State *ls)
{
int res;
BITMAP *aux;
	
	aux=(BITMAP *)lua_touserdata(ls,1);
	res=(int)bitmap_mask_color(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_create_bitmap(lua_State *ls)
{
BITMAP *aux;
int w,h;

	w=(int)lua_tonumber(ls,1);
	h=(int)lua_tonumber(ls,2);
	aux=create_bitmap(w,h);
	lua_pushlightuserdata(ls,aux);
	return 1;
}


int la_create_bitmap_ex(lua_State *ls)
{
BITMAP *aux;
int w,h,bpp;

	bpp=(int)lua_tonumber(ls,1);
	w=(int)lua_tonumber(ls,2);
	h=(int)lua_tonumber(ls,3);
	aux=create_bitmap_ex(bpp,w,h);
	lua_pushlightuserdata(ls,aux);
	return 1;
}


int la_create_sub_bitmap(lua_State *ls)
{
BITMAP *aux;
BITMAP *newb;
int x,y,w,h;

	aux=(BITMAP *)lua_touserdata(ls,1);
	x=(int)lua_tonumber(ls,2);
	y=(int)lua_tonumber(ls,3);
	w=(int)lua_tonumber(ls,4);
	h=(int)lua_tonumber(ls,5);
	newb=create_sub_bitmap(aux,x,y,w,h);
	lua_pushlightuserdata(ls,newb);
	return 1;
}


int la_create_system_bitmap(lua_State *ls)
{
BITMAP *aux;
int w,h;

	w=(int)lua_tonumber(ls,1);
	h=(int)lua_tonumber(ls,2);
	aux=create_system_bitmap(w,h);
	lua_pushlightuserdata(ls,aux);
	return 1;
}


int la_create_video_bitmap(lua_State *ls)
{
BITMAP *aux;
int w,h;

	w=(int)lua_tonumber(ls,1);
	h=(int)lua_tonumber(ls,2);
	aux=create_video_bitmap(w,h);
	lua_pushlightuserdata(ls,aux);
	return 1;
}


int la_destroy_bitmap(lua_State *ls)
{
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	destroy_bitmap(aux);
	return 0;
}


int la_get_clip_rect(lua_State *ls)
{
int x1,x2,y1,y2;
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	get_clip_rect(aux,&x1,&y1,&x2,&y2);
	lua_pushnumber(ls,x1);
	lua_pushnumber(ls,y1);
	lua_pushnumber(ls,x2);
	lua_pushnumber(ls,y2);
	return 4;
}


int la_get_clip_state(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=get_clip_state(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_inside_bitmap(lua_State *ls)
{
BITMAP *aux;
int x,y,clip,res;
	
	aux=(BITMAP *)lua_touserdata(ls,1);
	x=(int)lua_tonumber(ls,2);
	y=(int)lua_tonumber(ls,3);
	clip=(int)lua_tonumber(ls,4);
	res=is_inside_bitmap(aux,x,y,clip);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_linear_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_linear_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_memory_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_memory_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}



int la_is_planar_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_planar_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_same_bitmap(lua_State *ls)
{
BITMAP *b1,*b2;
int res;

	b1=(BITMAP *)lua_touserdata(ls,1);
	b2=(BITMAP *)lua_touserdata(ls,2);
	res=is_same_bitmap(b1,b2);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_screen_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_screen_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_sub_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_sub_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_system_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_system_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_is_video_bitmap(lua_State *ls)
{
BITMAP *aux;
int res;

	aux=(BITMAP *)lua_touserdata(ls,1);
	res=is_video_bitmap(aux);
	lua_pushnumber(ls,res);
	return 1;
}


int la_lock_bitmap(lua_State *ls)
{
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	lock_bitmap(aux);
	return 0;
}


int la_release_bitmap(lua_State *ls)
{
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	release_bitmap(aux);
	return 0;
}


int la_release_screen(lua_State *ls)
{
	release_bitmap(screen);
	return 0;
}


int la_get_screen(lua_State *ls)
{
	lua_pushlightuserdata(ls,screen);
	return 1;
}


int la_get_screen_h(lua_State *ls)
{
	lua_pushnumber(ls,screen->h);
	return 1;
}


int la_get_screen_w(lua_State *ls)
{
	lua_pushnumber(ls,screen->w);
	return 1;
}


int la_set_clip_rect(lua_State *ls)
{
BITMAP *aux;
int x1,y1,x2,y2;
	
	aux=(BITMAP *)lua_touserdata(ls,1);
	x1=(int)lua_tonumber(ls,2);
	y1=(int)lua_tonumber(ls,3);
	x2=(int)lua_tonumber(ls,4);
	y2=(int)lua_tonumber(ls,5);
	set_clip_rect(aux,x1,y1,x2,y2);
	return 0;
}


int la_set_clip_state(lua_State *ls)
{
BITMAP *aux;
int state;

	aux=(BITMAP *)lua_touserdata(ls,1);
	state=(int)lua_tonumber(ls,2);
	set_clip_state(aux,state);
	return 0;
}


int la_get_virtual_h(lua_State *ls)
{
	lua_pushnumber(ls,VIRTUAL_H);
	return 1;
}


int la_get_virtual_w(lua_State *ls)
{
	lua_pushnumber(ls,VIRTUAL_W);
	return 1;
}


lua_State * la_register_009(lua_State *ls)
{
	lua_register(ls,"acquire_bitmap",la_acquire_bitmap);
	lua_register(ls,"acquire_screen",la_acquire_screen);
	lua_register(ls,"add_clip_rect",la_add_clip_rect);
	lua_register(ls,"bitmap_color_depth",la_bitmap_color_depth);
	lua_register(ls,"bitmap_mask_color",la_bitmap_mask_color);
	lua_register(ls,"create_bitmap",la_create_bitmap);
	lua_register(ls,"create_bitmap_ex",la_create_bitmap_ex);
	lua_register(ls,"create_sub_bitmap",la_create_sub_bitmap);
	lua_register(ls,"create_system_bitmap",la_create_system_bitmap);
	lua_register(ls,"create_video_bitmap",la_create_video_bitmap);
	lua_register(ls,"destroy_bitmap",la_destroy_bitmap);
	lua_register(ls,"get_clip_rect",la_get_clip_rect);
	lua_register(ls,"get_clip_state",la_get_clip_state);
	lua_register(ls,"is_inside_bitmap",la_is_inside_bitmap);
	lua_register(ls,"is_linear_bitmap",la_is_linear_bitmap);
	lua_register(ls,"is_memory_bitmap",la_is_memory_bitmap);
	lua_register(ls,"is_planar_bitmap",la_is_planar_bitmap);
	lua_register(ls,"is_same_bitmap",la_is_same_bitmap);
	lua_register(ls,"is_screen_bitmap",la_is_screen_bitmap);
	lua_register(ls,"is_sub_bitmap",la_is_sub_bitmap);
	lua_register(ls,"is_system_bitmap",la_is_system_bitmap);
	lua_register(ls,"is_video_bitmap",la_is_video_bitmap);
	lua_register(ls,"lock_bitmap",la_lock_bitmap);
	lua_register(ls,"release_bitmap",la_release_bitmap);
	lua_register(ls,"release_screen",la_release_screen);
	lua_register(ls,"get_screen",la_get_screen);
	lua_register(ls,"get_screen_h",la_get_screen_h);
	lua_register(ls,"get_screen_w",la_get_screen_w);
	lua_register(ls,"set_clip_rect",la_set_clip_rect);
	lua_register(ls,"set_clip_state",la_set_clip_state);
	lua_register(ls,"get_virtual_h",la_get_virtual_h);
	lua_register(ls,"get_virtual_w",la_get_virtual_w);
	return ls;
}
