/*
	LuAlleg.
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#include "la_010.h"
#include "la_def.h"


int la_get_color_conversion(lua_State *ls)
{
int res;

	res=get_color_conversion();
	lua_pushnumber(ls,res);
	return 1;
}


int la_load_bitmap(lua_State *ls)
{
BITMAP *img;
char name[LASTRLEN];
PALETTE pal;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	img=load_bitmap(name,pal);
	lua_pushlightuserdata(ls,img);
	lua_pushlightuserdata(ls,pal);
	return 2;
}


int la_load_bmp(lua_State *ls)
{
BITMAP *img;
char name[LASTRLEN];
PALETTE pal;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	img=load_bmp(name,pal);
	lua_pushlightuserdata(ls,img);
	lua_pushlightuserdata(ls,pal);
	return 2;
}


int la_load_lbm(lua_State *ls)
{
BITMAP *img;
char name[LASTRLEN];
PALETTE pal;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	img=load_lbm(name,pal);
	lua_pushlightuserdata(ls,img);
	lua_pushlightuserdata(ls,pal);
	return 2;
}


int la_load_pcx(lua_State *ls)
{
BITMAP *img;
char name[LASTRLEN];
PALETTE pal;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	img=load_pcx(name,pal);
	lua_pushlightuserdata(ls,img);
	lua_pushlightuserdata(ls,pal);
	return 2;
}


int la_load_tga(lua_State *ls)
{
BITMAP *img;
char name[LASTRLEN];
PALETTE pal;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	img=load_tga(name,pal);
	lua_pushlightuserdata(ls,img);
	lua_pushlightuserdata(ls,pal);
	return 2;

}


int la_save_bitmap(lua_State *ls)
{
RGB *pal;
BITMAP *aux;
char name[LASTRLEN];
int res;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	aux=(BITMAP *)lua_touserdata(ls,2);
	pal=(RGB *)lua_touserdata(ls,3);
	res=save_bitmap(name,aux,pal);
	lua_pushnumber(ls,res);
	return 1;
}


int la_save_bmp(lua_State *ls)
{
RGB *pal;
BITMAP *aux;
char name[LASTRLEN];
int res;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	aux=(BITMAP *)lua_touserdata(ls,2);
	pal=(RGB *)lua_touserdata(ls,3);
	res=save_bmp(name,aux,pal);
	lua_pushnumber(ls,res);
	return 1;
}


int la_save_pcx(lua_State *ls)
{
RGB *pal;
BITMAP *aux;
char name[LASTRLEN];
int res;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	aux=(BITMAP *)lua_touserdata(ls,2);
	pal=(RGB *)lua_touserdata(ls,3);
	res=save_pcx(name,aux,pal);
	lua_pushnumber(ls,res);
	return 1;
}


int la_save_tga(lua_State *ls)
{
RGB *pal;
BITMAP *aux;
char name[LASTRLEN];
int res;

	memset(name,0,sizeof(char)*LASTRLEN);
	strcpy(name,lua_tostring(ls,1));
	aux=(BITMAP *)lua_touserdata(ls,2);
	pal=(RGB *)lua_touserdata(ls,3);
	res=save_tga(name,aux,pal);
	lua_pushnumber(ls,res);
	return 1;
}


int la_set_color_conversion(lua_State *ls)
{
int cc;

	cc=(int)lua_tonumber(ls,1); 
	set_color_conversion(cc);
	return 0;
}


lua_State * la_register_010(lua_State *ls)
{
	lua_register(ls,"load_bitmap",la_load_bitmap);
	lua_register(ls,"load_bmp",la_load_bmp);
	lua_register(ls,"load_lbm",la_load_lbm);
	lua_register(ls,"load_pcx",la_load_pcx);
	lua_register(ls,"load_tga",la_load_tga);
	lua_register(ls,"save_bitmap",la_save_bitmap);
	lua_register(ls,"save_bmp",la_save_bmp);
	lua_register(ls,"save_pcx",la_save_pcx);
	lua_register(ls,"save_tga",la_save_tga);
	lua_register(ls,"set_color_conversion",la_set_color_conversion);
	return ls;
}

