/*
	LuAlleg.
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#include "la_020.h"
#include "la_def.h"

int la_color_map(lua_State *ls);
int la_create_blender_table(lua_State *ls);
int la_create_color_table(lua_State *ls);
int la_create_light_table(lua_State *ls);


int la_create_trans_table(lua_State *ls)
{
COLOR_MAP table;
PALETTE pal;
int r,g,b;

	get_palette(pal);
	r=(int)lua_tonumber(ls,1);
	g=(int)lua_tonumber(ls,2);
	b=(int)lua_tonumber(ls,3);
	create_trans_table(&table,pal,r,g,b,NULL);
	color_map=&table;
	lua_pushlightuserdata(ls,color_map);
	return 1;
}


int la_drawing_mode(lua_State *ls);
int la_set_add_blender(lua_State *ls);


int la_set_alpha_blender(lua_State *ls)
{
 	set_alpha_blender();
	return 0;
}


int la_set_blender_mode(lua_State *ls);
int la_set_blender_mode_ex(lua_State *ls);
int la_set_burn_blender(lua_State *ls);
int la_set_color_blender(lua_State *ls);
int la_set_difference_blender(lua_State *ls);
int la_set_dissolve_blender(lua_State *ls);
int la_set_dodge_blender(lua_State *ls);
int la_set_hue_blender(lua_State *ls);
int la_set_invert_blender(lua_State *ls);
int la_set_luminance_blender(lua_State *ls);
int la_set_multiply_blender(lua_State *ls);
int la_set_saturation_blender(lua_State *ls);
int la_set_screen_blender(lua_State *ls);


int la_set_trans_blender(lua_State *ls)
{
int r,g,b,a;

	r=(int)lua_tonumber(ls,1);
	g=(int)lua_tonumber(ls,2);
	b=(int)lua_tonumber(ls,3);
	a=(int)lua_tonumber(ls,4);
	set_trans_blender(r,g,b,a);
	return 0;
}


int la_set_write_alpha_blender(lua_State *ls)
{
	set_write_alpha_blender();
	return 0;
}

int la_solid_mode(lua_State *ls);
int la_xor_mode(lua_State *ls);

lua_State * la_register_020(lua_State *ls)
{
	lua_register(ls,"create_trans_table",la_create_trans_table);
	lua_register(ls,"set_trans_blender",la_set_trans_blender);
	lua_register(ls,"set_alpha_blender",la_set_alpha_blender);
	lua_register(ls,"set_write_alpha_blender",la_set_write_alpha_blender);
	return ls;
}

