/*
	la_031.c
	Description: Tiene el codigo para manejar los ficheros de datos desde Lua.
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#include "la_031.h"
#include "la_def.h"


lua_State * la_register_031(lua_State *ls)
{
	lua_register(ls,"load_datafile",la_load_datafile);
	lua_register(ls,"unload_datafile",la_unload_datafile);
	lua_register(ls,"get_datafile_object",la_get_datafile_object);
	return ls;
}


int la_load_datafile(lua_State *ls)
{
char buf[LASTRLEN];
DATAFILE *data;

	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,1));
	data=load_datafile(buf);
	lua_pushlightuserdata(ls,data);
	return 1;
}


int la_unload_datafile(lua_State *ls)
{
DATAFILE *df;

	df=(DATAFILE *)lua_touserdata(ls,1);
	unload_datafile(df);
	return 0;
}


int la_get_datafile_object(lua_State *ls)
{
DATAFILE *df;
char buf[LASTRLEN];
int i=0;
char found=0;

	memset(buf,0,sizeof(char)*LASTRLEN);
	df=(DATAFILE *)lua_touserdata(ls,1);
	strcpy(buf,lua_tostring(ls,2));
	
	for (i=0; df[i].type != DAT_END; i++)
	{
		if (stricmp(get_datafile_property(df+i, DAT_ID('N','A','M','E')),buf) == 0) 
		{
			 lua_pushlightuserdata(ls,(df+i)->dat);
			 found=1;
		}
	}
	if (!found) lua_pushlightuserdata(ls,NULL);
	return 1;
}

