/*
	lalfont
	Description: A wrapper to use Alfont from LUA.
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/


#include "lalfont.h"
#include "la_def.h"
#include <allegro.h>
#include <string.h>


int lalfont_init(lua_State *ls)
{
#if HAVE_ALFONT_H
int res;
	res=alfont_init();
	lua_pushnumber(ls,res);
	return 1;
#else
	return 0;
#endif
}


int lalfont_load_font(lua_State *ls)
{
#if HAVE_ALFONT_H
char buf[LASTRLEN];
ALFONT_FONT *fnt;

	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,1));
	fnt=alfont_load_font(buf);
	lua_pushlightuserdata(ls,fnt);
	return 1;
#else
	return 0;
#endif
}


int lalfont_set_font_size(lua_State *ls)
{
#if HAVE_ALFONT_H
int size;
ALFONT_FONT *fnt;
	
	fnt=(ALFONT_FONT *)lua_touserdata(ls,1);
	size=(int)lua_tonumber(ls,2);
	alfont_set_font_size(fnt,size);
#endif
	return 0;
}


int lalfont_textout_centre_aa(lua_State *ls)
{
#if HAVE_ALFONT_H
	ALFONT_FONT *fnt;
#endif

BITMAP *bmp;
char buf[LASTRLEN];
int x,y,col;

	bmp=(BITMAP *)lua_touserdata(ls,1);
#if HAVE_ALFONT_H
	fnt=(ALFONT_FONT *)lua_touserdata(ls,2);
#endif
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
#if HAVE_ALFONT_H
	alfont_textout_centre_aa_ex(bmp,fnt,buf,x,y,col,-1);
	return 0;
#endif
#if !HAVE_ALFONT_H
	bmp=(BITMAP *)lua_touserdata(ls,1);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
	textout_centre_ex(bmp,font,buf,x,y,col,-1);
	return 0;
#endif
}


int lalfont_textout_aa(lua_State *ls)
{
#if HAVE_ALFONT_H
	ALFONT_FONT *fnt;
#endif

BITMAP *bmp;
char buf[LASTRLEN];
int x,y,col;

	bmp=(BITMAP *)lua_touserdata(ls,1);
#if HAVE_ALFONT_H
	fnt=(ALFONT_FONT *)lua_touserdata(ls,2);
#endif
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
#if HAVE_ALFONT_H
	alfont_textout_aa_ex(bmp,fnt,buf,x,y,col,-1);
	return 0;
#endif
#if !HAVE_ALFONT_H
	bmp=(BITMAP *)lua_touserdata(ls,1);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
	textout_ex(bmp,font,buf,x,y,col,-1);
	return 0;
#endif
}


int lalfont_textout(lua_State *ls)
{
#if HAVE_ALFONT_H
	ALFONT_FONT *fnt;
#endif

BITMAP *bmp;
char buf[LASTRLEN];
int x,y,col;

	bmp=(BITMAP *)lua_touserdata(ls,1);
#if HAVE_ALFONT_H
	fnt=(ALFONT_FONT *)lua_touserdata(ls,2);
#endif
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
#if HAVE_ALFONT_H
	alfont_textout_ex(bmp,fnt,buf,x,y,col,-1);
	return 0;
#endif
#if !HAVE_ALFONT_H
	bmp=(BITMAP *)lua_touserdata(ls,1);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
	textout_ex(bmp,font,buf,x,y,col,-1);
	return 0;
#endif
}


int lalfont_textout_centre(lua_State *ls)
{
#if HAVE_ALFONT_H
	ALFONT_FONT *fnt;
#endif

BITMAP *bmp;
char buf[LASTRLEN];
int x,y,col;

	bmp=(BITMAP *)lua_touserdata(ls,1);
#if HAVE_ALFONT_H
	fnt=(ALFONT_FONT *)lua_touserdata(ls,2);
#endif
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
#if HAVE_ALFONT_H
	alfont_textout_centre_ex(bmp,fnt,buf,x,y,col,-1);
	return 0;
#endif
#if !HAVE_ALFONT_H
	bmp=(BITMAP *)lua_touserdata(ls,1);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,3));
	x=(int)lua_tonumber(ls,4);
	y=(int)lua_tonumber(ls,5);
	col=(int)lua_tonumber(ls,6);
	textout_centre_ex(bmp,font,buf,x,y,col,-1);
	return 0;
#endif
}


int lalfont_textprintf_ex(lua_State *ls)
{
#if HAVE_ALFONT_H
	ALFONT_FONT *fnt;
#endif

BITMAP *bmp;
char buf[LASTRLEN];
int x,y,col;

	bmp=(BITMAP *)lua_touserdata(ls,1);
#if HAVE_ALFONT_H
	fnt=(ALFONT_FONT *)lua_touserdata(ls,2);
#endif
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	col=(int)lua_tonumber(ls,5);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,7));
#if HAVE_ALFONT_H
	alfont_textprintf_ex(bmp,fnt,x,y,col,-1,buf);
	return 0;
#endif
#if !HAVE_ALFONT_H
	bmp=(BITMAP *)lua_touserdata(ls,1);
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	col=(int)lua_tonumber(ls,5);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,7));
	textprintf_ex(bmp,font,x,y,col,-1,buf);
	return 0;
#endif
}


int lalfont_textprintf_aa_ex(lua_State *ls)
{
#if HAVE_ALFONT_H
	ALFONT_FONT *fnt;
#endif

BITMAP *bmp;
char buf[LASTRLEN];
int x,y,col;

	bmp=(BITMAP *)lua_touserdata(ls,1);
#if HAVE_ALFONT_H
	fnt=(ALFONT_FONT *)lua_touserdata(ls,2);
#endif
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	col=(int)lua_tonumber(ls,5);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,7));
#if HAVE_ALFONT_H
	alfont_textprintf_aa_ex(bmp,fnt,x,y,col,-1,buf);
	return 0;
#endif
#if !HAVE_ALFONT_H
	bmp=(BITMAP *)lua_touserdata(ls,1);
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	col=(int)lua_tonumber(ls,5);
	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,7));
	textprintf_ex(bmp,font,x,y,col,-1,buf);
	return 0;
#endif
}



int lalfont_destroy_font(lua_State *ls)
{
#if HAVE_ALFONT_H
ALFONT_FONT *fnt;

	fnt=(ALFONT_FONT *)lua_touserdata(ls,1);
	alfont_destroy_font(fnt);
#endif
	return 0;
}


int lalfont_exit(lua_State *ls)
{
#if HAVE_ALFONT_H
	alfont_exit();
#endif
	return 0;
}


lua_State * la_register_lalfont_functions(lua_State *ls)
{
	lua_register(ls,"alfont_init",lalfont_init);
	lua_register(ls,"alfont_load_font",lalfont_load_font);
	lua_register(ls,"alfont_set_font_size",lalfont_set_font_size);
	lua_register(ls,"alfont_textout",lalfont_textout);
	lua_register(ls,"alfont_textout_aa",lalfont_textout_aa);
	lua_register(ls,"alfont_textprintf_ex",lalfont_textprintf_ex);
	lua_register(ls,"alfont_textprintf_aa_ex",lalfont_textprintf_aa_ex);
	lua_register(ls,"alfont_textout_centre",lalfont_textout_centre);
	lua_register(ls,"alfont_textout_centre_aa",lalfont_textout_centre_aa);
	lua_register(ls,"alfont_destroy_font",lalfont_destroy_font);
	lua_register(ls,"alfont_exit",lalfont_exit);
	return ls;
}
