/*
	Lualleg 0.1 by Traperic <traperic@alamin.org>
	This is a very simple wrapper to use Allegro from a LUA script.
	See COPYING for copyright information.
	2005 Traperic Software.
*/

#include "config.h"
#include <allegro.h>
#include <string.h>
#include "lualleg.h"


lua_State * la_register_lualleg_functions(lua_State *ls)
{
	ls=la_register_009(ls);
	ls=la_register_010(ls);
	ls=la_register_020(ls);
	ls=la_register_031(ls);
	
	lua_register(ls,"get_allegro_def",la_get_allegro_def);
	lua_register(ls,"allegro_init",la_allegro_init);
	lua_register(ls,"allegro_exit",la_allegro_exit);
	lua_register(ls,"get_allegro_id",la_get_allegro_id);
	lua_register(ls,"get_allegro_version",la_get_allegro_version);
	lua_register(ls,"get_allegro_subversion",la_get_allegro_sub_version);
	lua_register(ls,"get_allegro_wip_version",la_get_allegro_wip_version);
	lua_register(ls,"get_allegro_version_str",la_get_allegro_version_str);
	lua_register(ls,"get_allegro_date_str",la_get_allegro_date_str);
	lua_register(ls,"get_allegro_date",la_get_allegro_date);
	lua_register(ls,"get_os_type",la_get_os_type);
	lua_register(ls,"get_os_multitasking",la_get_os_multitasking);
	lua_register(ls,"allegro_message",la_allegro_message);
	lua_register(ls,"set_window_title",la_set_window_title);
	lua_register(ls,"desktop_color_depth",la_desktop_color_depth);
	lua_register(ls,"get_desktop_resolution",la_get_desktop_resolution);
	lua_register(ls,"check_cpu",la_check_cpu);
	lua_register(ls,"get_cpu_vendor",la_get_cpu_vendor);
	lua_register(ls,"get_cpu_family",la_get_cpu_family);
	lua_register(ls,"get_cpu_model",la_get_cpu_model);
	lua_register(ls,"get_cpu_capabilities",la_get_cpu_capabilities);
	
	
	lua_register(ls,"get_bitmap_vars",la_get_bitmap_vars);
	lua_register(ls,"get_rle_sprite_vars",la_get_rle_sprite_vars);
	lua_register(ls,"get_compiled_sprite_vars",la_get_compiled_sprite_vars);
	lua_register(ls,"get_joystick_info_vars",la_get_joystick_info_vars);
	lua_register(ls,"get_joystick_button_info_vars",la_get_joystick_button_info_vars);
	lua_register(ls,"get_joystick_stick_info_vars",la_get_joystick_stick_info_vars);
	lua_register(ls,"get_joystick_axis_info_vars",la_get_joystick_axis_info_vars);
	lua_register(ls,"get_gfx_mode_list_vars",la_get_gfx_mode_list_vars);
	lua_register(ls,"get_gfx_mode_vars",la_get_gfx_mode_vars);
	lua_register(ls,"get_rgb_vars",la_get_rgb_vars);
	lua_register(ls,"get_v3d_vars",la_get_v3d_vars);
	lua_register(ls,"get_v3d_f_vars",la_get_v3d_f_vars);
	lua_register(ls,"get_al_ffblk_vars",la_get_al_ffblk_vars);
	lua_register(ls,"get_datafile_vars",la_get_datafile_vars);
	lua_register(ls,"get_matrix_vars",la_get_matrix_vars);
	
	
	lua_register(ls,"set_uformat",la_set_uformat);
	
	
	lua_register(ls,"install_mouse",la_install_mouse);
	lua_register(ls,"remove_mouse",la_remove_mouse);
	lua_register(ls,"poll_mouse",la_poll_mouse);
	lua_register(ls,"mouse_needs_poll",la_mouse_needs_poll);
	lua_register(ls,"enable_hardware_cursor",la_enable_hardware_cursor);
	lua_register(ls,"disable_hardware_cursor",la_disable_hardware_cursor);
	lua_register(ls,"select_mouse_cursor",la_select_mouse_cursor);
	lua_register(ls,"set_mouse_cursor_bitmap",la_set_mouse_cursor_bitmap);
	lua_register(ls,"get_mouse_x",la_get_mouse_x);
	lua_register(ls,"get_mouse_y",la_get_mouse_y);
	lua_register(ls,"get_mouse_z",la_get_mouse_z);
	lua_register(ls,"get_mouse_b",la_get_mouse_b);
	lua_register(ls,"get_mouse_pos",la_get_mouse_pos);
	lua_register(ls,"get_mouse_sprite",la_get_mouse_sprite);
	lua_register(ls,"get_mouse_x_focus",la_get_mouse_x_focus);
	lua_register(ls,"get_mouse_y_focus",la_get_mouse_y_focus);
	lua_register(ls,"show_mouse",la_show_mouse);
	lua_register(ls,"scare_mouse",la_scare_mouse);
	lua_register(ls,"scare_mouse_area",la_scare_mouse_area);
	lua_register(ls,"unscare_mouse",la_unscare_mouse);
	lua_register(ls,"get_freeze_mouse_flag",la_get_freeze_mouse_flag);
	lua_register(ls,"position_mouse",la_position_mouse);
	lua_register(ls,"position_mouse_z",la_position_mouse_z);
	lua_register(ls,"set_mouse_range",la_set_mouse_range);
	lua_register(ls,"set_mouse_speed",la_set_mouse_speed);
	lua_register(ls,"set_mouse_sprite",la_set_mouse_sprite);
	lua_register(ls,"set_mouse_sprite_focus",la_set_mouse_sprite_focus);
	lua_register(ls,"get_mouse_mickeys",la_get_mouse_mickeys);
	
	
	lua_register(ls,"install_timer",la_install_timer);
	lua_register(ls,"remove_timer",la_remove_timer);
	lua_register(ls,"get_retrace_count",la_get_retrace_count);
	lua_register(ls,"rest",la_rest);
	
	lua_register(ls,"install_keyboard",la_install_keyboard);
	lua_register(ls,"clear_keybuf",la_clear_keybuf);
	lua_register(ls,"readkey",la_readkey);
	lua_register(ls,"keypressed",la_keypressed);
		
	lua_register(ls,"set_color_depth",la_set_color_depth);
	lua_register(ls,"set_gfx_mode",la_set_gfx_mode);
	lua_register(ls,"textprintf_ex",la_textprintf_ex);
	lua_register(ls,"vsync",la_vsync);
	lua_register(ls,"get_gfx_mode",la_get_gfx_mode);
	lua_register(ls,"get_font",la_get_font);
	lua_register(ls,"makecol",la_makecol);
	lua_register(ls,"rectfill",la_rectfill);
	lua_register(ls,"putpixel",la_putpixel);
	lua_register(ls,"drawing_mode",la_drawing_mode);
	lua_register(ls,"draw_sprite",la_draw_sprite);
	lua_register(ls,"draw_trans_sprite",la_draw_trans_sprite);
	lua_register(ls,"clear_to_color",la_clear_to_color);
	lua_register(ls,"clear",la_clear);
	lua_register(ls,"blit",la_blit);
	lua_register(ls,"text",la_text);
	lua_register(ls,"load_sample",la_load_sample);
	lua_register(ls,"destroy_sample",la_destroy_sample);
	lua_register(ls,"play_sample",la_play_sample);
	lua_register(ls,"install_sound",la_install_sound);
	return ls;
}

/*******************************************************************************
Section: Lualleg functions
*******************************************************************************/
int la_get_allegro_def(lua_State *ls)
{
char buf[LASTRLEN];

	strcpy(buf,lua_tostring(ls,1));
	
	if (!strcmp(buf,"DRAW_MODE_TRANS"))
	{
		lua_pushnumber(ls,DRAW_MODE_TRANS);
	}
	if (!strcmp(buf,"DRAW_MODE_XOR"))
	{
		lua_pushnumber(ls,DRAW_MODE_XOR);
	}
	if (!strcmp(buf,"DRAW_MODE_SOLID"))
	{
		lua_pushnumber(ls,DRAW_MODE_SOLID);
	}
	if (!strcmp(buf,"GFX_AUTODETECT"))
	{
		lua_pushnumber(ls,GFX_AUTODETECT);
	}
	if (!strcmp(buf,"GFX_AUTODETECT_WINDOWED"))
	{
		lua_pushnumber(ls,GFX_AUTODETECT_WINDOWED);
	}
	if (!strcmp(buf,"MOUSE_CURSOR_NONE"))
	{
		lua_pushnumber(ls,MOUSE_CURSOR_NONE);
	}
	if (!strcmp(buf,"MOUSE_CURSOR_ALLEGRO"))
	{
		lua_pushnumber(ls,MOUSE_CURSOR_ALLEGRO);
	}
	if (!strcmp(buf,"MOUSE_CURSOR_ARROW"))
	{
		lua_pushnumber(ls,MOUSE_CURSOR_ARROW);
	}
	if (!strcmp(buf,"MOUSE_CURSOR_BUSY"))
	{
		lua_pushnumber(ls,MOUSE_CURSOR_BUSY);
	}
	if (!strcmp(buf,"MOUSE_CURSOR_QUESTION"))
	{
		lua_pushnumber(ls,MOUSE_CURSOR_QUESTION);
	}
	if (!strcmp(buf,"MOUSE_CURSOR_EDIT"))
	{
		lua_pushnumber(ls,MOUSE_CURSOR_EDIT);
	}
	if (!strcmp(buf,"U_ASCII"))
	{
		lua_pushnumber(ls,U_ASCII);
	}
	if (!strcmp(buf,"U_UTF8"))
	{
		lua_pushnumber(ls,U_UTF8);
	}
	if (!strcmp(buf,"U_ASCII_CP"))
	{
		lua_pushnumber(ls,U_ASCII_CP);
	}
	return 1;
}

/*******************************************************************************
Section: Using Allegro
*******************************************************************************/

int la_allegro_init(lua_State *ls)
{
	allegro_init();
	return 0;
}


int la_allegro_exit(lua_State *ls)
{
	allegro_exit();
	return 0;
}


int la_get_allegro_id(lua_State *ls)
{
	lua_pushstring(ls,allegro_id);
	return 1;
}


int la_get_allegro_version(lua_State *ls)
{
	lua_pushnumber(ls,ALLEGRO_VERSION);
	return 1;
}


int la_get_allegro_sub_version(lua_State *ls)
{
	lua_pushnumber(ls,ALLEGRO_SUB_VERSION);
	return 1;
}


int la_get_allegro_wip_version(lua_State *ls)
{
	lua_pushnumber(ls,ALLEGRO_WIP_VERSION);
	return 1;
}


int la_get_allegro_version_str(lua_State *ls)
{
	lua_pushstring(ls,ALLEGRO_VERSION_STR);
	return 1;
}


int la_get_allegro_date_str(lua_State *ls)
{
	lua_pushstring(ls,ALLEGRO_DATE_STR);
	return 1;
}


int la_get_allegro_date(lua_State *ls)
{
	lua_pushnumber(ls,ALLEGRO_DATE);
	return 1;
}


int la_get_os_type(lua_State *ls)
{
	lua_pushnumber(ls,os_type);
	return 1;
}


int la_get_os_multitasking(lua_State *ls)
{
	lua_pushnumber(ls,os_multitasking);
	return 1;
}


int la_allegro_message(lua_State *ls)
{
char buf1[512];

	strcpy(buf1,lua_tostring(ls,1));
	allegro_message(buf1);
	return 0;
}


int la_set_window_title(lua_State *ls)
{
char buf[512];

	strcpy(buf,lua_tostring(ls,1));
	set_window_title(buf);
	return 0;
}


int la_desktop_color_depth(lua_State *ls)
{
	lua_pushnumber(ls,desktop_color_depth());
	return 1;
}


int la_get_desktop_resolution(lua_State *ls)
{
int w;
int h;

	get_desktop_resolution(&w,&h);
	lua_pushnumber(ls,w);
	lua_pushnumber(ls,h);
	return 2;
}


int la_check_cpu(lua_State *ls)
{
	check_cpu();
	return 0;
}


int la_get_cpu_vendor(lua_State *ls)
{
	lua_pushstring(ls,cpu_vendor);
	return 1;
}


int la_get_cpu_family(lua_State *ls)
{
	lua_pushnumber(ls,cpu_family);
	return 1;
}


int la_get_cpu_model(lua_State *ls)
{
	lua_pushnumber(ls,cpu_model);
	return 1;
}


int la_get_cpu_capabilities(lua_State *ls)
{
	lua_pushnumber(ls,cpu_capabilities);
	return 1;
}


/*******************************************************************************
Section: Structures and types defined by Allegro
*******************************************************************************/


/*@TODO Can't access to the line[] data in the type BITMAP.*/
int la_get_bitmap_vars(lua_State *ls)
{
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->w);
	lua_pushnumber(ls,aux->h);
	lua_pushnumber(ls,aux->clip);
	lua_pushnumber(ls,aux->cl);
	lua_pushnumber(ls,aux->cr);
	lua_pushnumber(ls,aux->ct);
	lua_pushnumber(ls,aux->cb);
	return 7;
}


int la_get_rle_sprite_vars(lua_State *ls)
{
RLE_SPRITE *aux;

	aux=(RLE_SPRITE *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->w);
	lua_pushnumber(ls,aux->h);
	lua_pushnumber(ls,aux->color_depth);
	return 3;
}


int la_get_compiled_sprite_vars(lua_State *ls)
{
COMPILED_SPRITE *aux;

	aux=(COMPILED_SPRITE *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->w);
	lua_pushnumber(ls,aux->h);
	lua_pushnumber(ls,aux->color_depth);
	return 3;
}


/*@TODO Pass correctly aux->stick and aux->button */
int la_get_joystick_info_vars(lua_State *ls)
{
JOYSTICK_INFO *aux;
int n;

	aux=(JOYSTICK_INFO *)lua_touserdata(ls,1);
	n=(int)lua_tonumber(ls,2);
	lua_pushnumber(ls,aux->flags);
	lua_pushnumber(ls,aux->num_sticks);
	lua_pushnumber(ls,aux->num_buttons);
//	lua_pushlightuserdata(ls,aux->stick[n]);
//	lua_pushlightuserdata(ls,aux->button[n]);
	return 3;
}


int la_get_joystick_button_info_vars(lua_State *ls)
{
JOYSTICK_BUTTON_INFO *aux;

	aux=(JOYSTICK_BUTTON_INFO *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->b);
	lua_pushstring(ls,aux->name);
	return 2;
}


/*@TODO Fix passing aux->axis[n] */
int la_get_joystick_stick_info_vars(lua_State *ls)
{
JOYSTICK_STICK_INFO *aux;
int n;

	aux=(JOYSTICK_STICK_INFO *)lua_touserdata(ls,1);
	n=(int)lua_tonumber(ls,2);
	lua_pushnumber(ls,aux->flags);
	lua_pushnumber(ls,aux->num_axis);
//	lua_pushlightuserdata(ls,aux->axis[n]);
	lua_pushstring(ls,aux->name);
	return 3;
}


int la_get_joystick_axis_info_vars(lua_State *ls)
{
JOYSTICK_AXIS_INFO *aux;

	aux=(JOYSTICK_AXIS_INFO *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->pos);
	lua_pushnumber(ls,aux->d1);
	lua_pushnumber(ls,aux->d2);
	lua_pushstring(ls,aux->name);
	return 4;
}


int la_get_gfx_mode_list_vars(lua_State *ls)
{
GFX_MODE_LIST *aux;

	aux=(GFX_MODE_LIST *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->num_modes);
	lua_pushlightuserdata(ls,aux->mode);
	return 2;
}


int la_get_gfx_mode_vars(lua_State *ls)
{
GFX_MODE *aux;

	aux=(GFX_MODE *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->width);
	lua_pushnumber(ls,aux->height);
	lua_pushnumber(ls,aux->bpp);
	return 3;
}


int la_get_rgb_vars(lua_State *ls)
{
RGB *aux;

	aux=(RGB *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->r);
	lua_pushnumber(ls,aux->g);
	lua_pushnumber(ls,aux->b);
	return 3;
}


int la_get_v3d_vars(lua_State *ls)
{
V3D *aux;

	aux=(V3D *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->x);
	lua_pushnumber(ls,aux->y);
	lua_pushnumber(ls,aux->z);
	lua_pushnumber(ls,aux->u);
	lua_pushnumber(ls,aux->v);
	lua_pushnumber(ls,aux->c);
	return 6;
}


int la_get_v3d_f_vars(lua_State *ls)
{
V3D_f *aux;

	aux=(V3D_f *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->x);
	lua_pushnumber(ls,aux->y);
	lua_pushnumber(ls,aux->z);
	lua_pushnumber(ls,aux->u);
	lua_pushnumber(ls,aux->v);
	lua_pushnumber(ls,aux->c);
	return 6;
}


/*@TODO add support for COLOR_MAP and add support for RGB_MAP.*/


int la_get_al_ffblk_vars(lua_State *ls)
{
struct al_ffblk *aux;
	
	aux=(struct al_ffblk *)lua_touserdata(ls,1);
	lua_pushnumber(ls,aux->attrib);
	lua_pushlightuserdata(ls,(time_t *)aux->time);
	lua_pushnumber(ls,aux->size);
	lua_pushstring(ls,aux->name);
	return 4;
}


int la_get_datafile_vars(lua_State *ls)
{
DATAFILE *aux;

	aux=(DATAFILE *)lua_touserdata(ls,1);
	lua_pushlightuserdata(ls,aux->dat);
	lua_pushnumber(ls,aux->type);
	lua_pushnumber(ls,aux->size);
	lua_pushlightuserdata(ls,aux->prop);
	return 4;
}

int la_get_matrix_vars(lua_State *ls)
{
//MATRIX *aux;
	return 0;
}


/*******************************************************************************
Section: Mouse routines
*******************************************************************************/
int la_install_mouse(lua_State *ls)
{
int res;
	res=install_mouse();
	lua_pushnumber(ls,res);
	return 1;
}


int la_remove_mouse(lua_State *ls)
{
	remove_mouse();
	return 0;
}


int la_poll_mouse(lua_State *ls)
{
int res;

	res=poll_mouse();
	lua_pushnumber(ls,res);
	return 1;
}


int la_mouse_needs_poll(lua_State *ls)
{
int res;

	res=mouse_needs_poll();
	lua_pushnumber(ls,res);
	return 1;
}


int la_enable_hardware_cursor(lua_State *ls)
{
	enable_hardware_cursor();
	return 0;
}


int la_disable_hardware_cursor(lua_State *ls)
{
	disable_hardware_cursor();
	return 0;
}


int la_select_mouse_cursor(lua_State *ls)
{
int cursor;

	cursor=(int)lua_tonumber(ls,1);
	select_mouse_cursor(cursor);
	return 0;
}


int la_set_mouse_cursor_bitmap(lua_State *ls)
{
int cursor;
BITMAP *spr;

	cursor=(int)lua_tonumber(ls,1);
	spr=(BITMAP *)lua_touserdata(ls,2);
	set_mouse_cursor_bitmap(cursor,spr);
	return 0;
}


int la_get_mouse_x(lua_State *ls)
{
	lua_pushnumber(ls,mouse_x);
	return 1;
}


int la_get_mouse_y(lua_State *ls)
{
	lua_pushnumber(ls,mouse_y);
	return 1;
}


int la_get_mouse_z(lua_State *ls)
{
	lua_pushnumber(ls,mouse_z);
	return 1;
}


int la_get_mouse_b(lua_State *ls)
{
	lua_pushnumber(ls,mouse_b);
	return 1;
}


int la_get_mouse_pos(lua_State *ls)
{
	lua_pushnumber(ls,mouse_pos);
	return 1;
}


int la_get_mouse_sprite(lua_State *ls)
{
	lua_pushlightuserdata(ls,mouse_sprite);
	return 1;
}


int la_get_mouse_x_focus(lua_State *ls)
{
	lua_pushnumber(ls,mouse_x_focus);
	return 1;
}


int la_get_mouse_y_focus(lua_State *ls)
{
	lua_pushnumber(ls,mouse_y_focus);
	return 1;
}


int la_show_mouse(lua_State *ls)
{
BITMAP *dst;

	dst=(BITMAP *)lua_touserdata(ls,1);
	show_mouse(dst);
	return 0;
}


int la_scare_mouse(lua_State *ls)
{
	scare_mouse();
	return 0;
}


int la_scare_mouse_area(lua_State *ls)
{
int x,y,w,h;

	x=(int)lua_tonumber(ls,1);
	y=(int)lua_tonumber(ls,2);
	w=(int)lua_tonumber(ls,3);
	h=(int)lua_tonumber(ls,4);
	scare_mouse_area(x,y,w,h);
	return 0;
}


int la_unscare_mouse(lua_State *ls)
{
	unscare_mouse();
	return 0;
}


int la_get_freeze_mouse_flag(lua_State *ls)
{
	lua_pushnumber(ls,freeze_mouse_flag);
	return 1;
}


int la_position_mouse(lua_State *ls)
{
int x,y;

	x=(int)lua_tonumber(ls,1);
	y=(int)lua_tonumber(ls,2);
	position_mouse(x,y);
	return 0;
}


int la_position_mouse_z(lua_State *ls)
{
int z;

	z=(int)lua_tonumber(ls,1);
	position_mouse_z(z);
	return 0;
}


int la_set_mouse_range(lua_State *ls)
{
int x1,y1,x2,y2;

	x1=(int)lua_tonumber(ls,1);
	y1=(int)lua_tonumber(ls,2);
	x2=(int)lua_tonumber(ls,3);
	y2=(int)lua_tonumber(ls,4);
	set_mouse_range(x1,y1,x2,y2);
	return 0;
}


int la_set_mouse_speed(lua_State *ls)
{
int xspeed,yspeed;

	xspeed=(int)lua_tonumber(ls,1);
	yspeed=(int)lua_tonumber(ls,2);
	set_mouse_speed(xspeed,yspeed);
	return 0;
}


int la_set_mouse_sprite(lua_State *ls) 
{
BITMAP *aux;
	
	aux=(BITMAP *)lua_touserdata(ls,1);
	set_mouse_sprite(aux);
	return 0;
}


int la_set_mouse_sprite_focus(lua_State *ls)
{
int x,y;

	x=(int)lua_tonumber(ls,1);
	y=(int)lua_tonumber(ls,2);
	set_mouse_sprite_focus(x,y);
	return 0;
}


int la_get_mouse_mickeys(lua_State *ls)
{
int x,y;

	get_mouse_mickeys(&x,&y);
	lua_pushnumber(ls,x);
	lua_pushnumber(ls,y);
	return 2;
}


/*******************************************************************************
Section: Timer routines
*******************************************************************************/
int la_install_timer(lua_State *ls)
{
int res;
	res=install_timer();
	lua_pushnumber(ls,1);
	return 1;
}


int la_remove_timer(lua_State *ls)
{
	remove_timer();
	return 0;
}


int la_get_retrace_count(lua_State *ls)
{
	lua_pushnumber(ls,retrace_count);
	return 1;
}


int la_rest(lua_State *ls)
{
int r;

	r=(int)lua_tonumber(ls,1);
	rest(r);
	return 0;
}


/*******************************************************************************
Section: Keyboard routines
*******************************************************************************/
int la_install_keyboard(lua_State *ls)
{
int res;
	res=install_keyboard();
	lua_pushnumber(ls,res);
	return 1;
}


int la_remove_keyboard(lua_State *ls)
{
	remove_keyboard();
	return 0;
}


int la_poll_keyboard(lua_State *ls)
{
int res;

	res=poll_keyboard();
	lua_pushnumber(ls,res);
	return 1;
}


int la_keyboard_needs_poll(lua_State *ls)
{
int res;

	res=keyboard_needs_poll();
	lua_pushnumber(ls,res);
	return 1;
}


int la_get_key(lua_State *ls)
{
int k;

	k=(int)lua_tonumber(ls,1);
	if (key[k]) 
		lua_pushnumber(ls,1);
	else
		lua_pushnumber(ls,0);	
	return 1;
}

//@TODO do this function.
int la_get_key_shifts(lua_State *ls)
{
	return 0;
}

int la_readkey(lua_State *ls)
{
int res;

	res=readkey();
	lua_pushnumber(ls,1);
	return 1;
}

int la_keypressed(lua_State *ls)
{
int res;

	res=keypressed();
	lua_pushnumber(ls,res);
	return 1;
}


int la_scancode_to_ascii(lua_State *ls)
{   
int ascii;
      
	ascii=(int)lua_tonumber(ls,1);
	lua_pushnumber(ls,scancode_to_ascii(ascii));
	return 1;
}


int la_clear_keybuf(lua_State *ls)
{
	clear_keybuf();
	return 0;
}

int la_ureadkey(lua_State *ls);
int la_scancode_to_name(lua_State *ls);
int la_simulate_keypress(lua_State *ls);
int la_simulate_ukeypress(lua_State *ls);
int la_set_leds(lua_State *ls);

/*******************************************************************************
Section: Unicode routines
*******************************************************************************/

int la_set_uformat(lua_State *ls)
{
char buf[LASTRLEN];
char found=0;

	strcpy(buf,lua_tostring(ls,1));
	if (!strcmp(buf,"U_ASCII"))
	{
		set_uformat(U_ASCII);
		found=1;
	}
	if (!strcmp(buf,"U_ASCII_CP"))
	{
		set_uformat(U_ASCII_CP);
		found=1;
	}
	if (!strcmp(buf,"U_UNICODE"))
	{
		set_uformat(U_UNICODE);
		found=1;
	}
	if (!strcmp(buf,"U_UTF8"))
	{
		set_uformat(U_UTF8);
		found=1;
	}
	if (!found) set_uformat(U_UTF8);
	return 0;
}


int la_set_color_depth(lua_State *ls)
{
int d;

	d=(int)lua_tonumber(ls,1);
	set_color_depth(d);
	return 0;
}


int la_get_gfx_mode(lua_State *ls)
{
char mode[100];
char found=0;

	strcpy(mode,lua_tostring(ls,1));
	if (!strcmp("GFX_TEXT",mode)) 
	{
		lua_pushnumber(ls,GFX_TEXT);
		found=1;
	}
	if (!strcmp("GFX_AUTODETECT",mode)) 
	{
		lua_pushnumber(ls,GFX_AUTODETECT);
		found=1;
	}
	if (!strcmp("GFX_SAFE",mode)) 
	{
		lua_pushnumber(ls,GFX_SAFE);
		found=1;
	}
	if (!strcmp("GFX_AUTODETECT_WINDOWED",mode)) 
	{
		lua_pushnumber(ls,GFX_AUTODETECT_WINDOWED);
		found=1;
	}
	if (!found) lua_pushnumber(ls,GFX_AUTODETECT_WINDOWED);
	return 1;
}


int la_set_gfx_mode(lua_State *ls)
{
int res;
int mode;
int w;
int h;
int a;
int b;
	mode=(int)lua_tonumber(ls,1);
	w=(int)lua_tonumber(ls,2);
	h=(int)lua_tonumber(ls,3);
	a=(int)lua_tonumber(ls,4);
	b=(int)lua_tonumber(ls,5);
	res=set_gfx_mode(mode,w,h,a,b);
	lua_pushnumber(ls,res);
	return 1;
}


int la_clear_to_color(lua_State *ls)
{
BITMAP *aux=NULL;
int color;

	aux=(BITMAP *)lua_touserdata(ls,1);
	color=(int)lua_tonumber(ls,2);
	clear_to_color(aux,color);
	return 0;
}

int la_clear(lua_State *ls)
{
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	clear(aux);
	return 0;
}


int la_draw_sprite(lua_State *ls)
{
BITMAP *aux;
BITMAP *spr;
int x,y;

	aux=(BITMAP *)lua_touserdata(ls,1);
	spr=(BITMAP *)lua_touserdata(ls,2);
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	draw_sprite(aux,spr,x,y);
	return 0;
}


int la_draw_trans_sprite(lua_State *ls)
{
BITMAP *aux;
BITMAP *spr;
int x,y;

	aux=(BITMAP *)lua_touserdata(ls,1);
	spr=(BITMAP *)lua_touserdata(ls,2);
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	draw_trans_sprite(aux,spr,x,y);
	return 0;
}


int la_blit(lua_State *ls)
{
BITMAP *src=NULL;

	src=(BITMAP *)lua_touserdata(ls,1);
	acquire_bitmap(src);
//	vsync();
	blit(src,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	release_bitmap(src);
	return 0;
}


int la_textprintf_ex(lua_State *ls)
{
BITMAP *bmp;
FONT *f;
int x,y,color,bg;
char buf[LASTRLEN];

	bmp=(BITMAP *)lua_touserdata(ls,1);
	f=(FONT *)lua_touserdata(ls,2);
	x=(int)lua_tonumber(ls,3);
	y=(int)lua_tonumber(ls,4);
	color=(int)lua_tonumber(ls,5);
	bg=(int)lua_tonumber(ls,6);
	strcpy(buf,lua_tostring(ls,7));
	textprintf_ex(bmp,f,x,y,color,bg,"%s",buf);
	return 0;
}


int la_text(lua_State *ls)
{
int x,y;
char buf[200];

	x=(int)lua_tonumber(ls,1);
	y=(int)lua_tonumber(ls,2);
	strcpy(buf,lua_tostring(ls,3));
	textprintf_ex(screen,font,10,10,makecol(200,200,200),-1,"%s",buf);
	return 0;
}

int la_get_font(lua_State *ls)
{
	lua_pushlightuserdata(ls,font);
	return 1;
}

int la_makecol(lua_State *ls)
{
int r,g,b,res;

	r=(int)lua_tonumber(ls,1);
	g=(int)lua_tonumber(ls,2);
	b=(int)lua_tonumber(ls,3);
	res=makecol(r,g,b);
	lua_pushnumber(ls,res);
	return 1;
}


int la_vsync(lua_State *ls)
{
	vsync();
	return 0;
}


int la_load_sample(lua_State *ls)
{
SAMPLE *samp;
char buf[LASTRLEN];

	memset(buf,0,sizeof(char)*LASTRLEN);
	strcpy(buf,lua_tostring(ls,1));
	samp=load_sample(buf);
	lua_pushlightuserdata(ls,samp);
	return 1;
}


int la_destroy_sample(lua_State *ls)
{
SAMPLE *samp;

	samp=(SAMPLE *)lua_touserdata(ls,1);
	destroy_sample(samp);
	return 0;
}


int la_play_sample(lua_State *ls)
{
SAMPLE *samp;
int vol,pan,freq,loop;

	samp=(SAMPLE *)lua_touserdata(ls,1);
	vol=(int)lua_tonumber(ls,2);
	pan=(int)lua_tonumber(ls,3);
	freq=(int)lua_tonumber(ls,4);
	loop=(int)lua_tonumber(ls,5);
	play_sample(samp,vol,pan,freq,loop);
	return 0;
}


int la_install_sound(lua_State *ls)
{
	install_sound(DIGI_AUTODETECT,MIDI_NONE,NULL);
	return 0;
}

int la_rectfill(lua_State *ls)
{
int x1,y1,x2,y2,color;
BITMAP *aux;
	
	aux=(BITMAP *)lua_touserdata(ls,1);
	x1=(int)lua_tonumber(ls,2);
	y1=(int)lua_tonumber(ls,3);
	x2=(int)lua_tonumber(ls,4);
	y2=(int)lua_tonumber(ls,5);
	color=(int)lua_tonumber(ls,6);
	rectfill(aux,x1,y1,x2,y2,color);
	return 0;
}


int la_putpixel(lua_State *ls)
{
int x1,y1,color;
BITMAP *aux;

	aux=(BITMAP *)lua_touserdata(ls,1);
	x1=(int)lua_tonumber(ls,2);
	y1=(int)lua_tonumber(ls,3);
	color=(int)lua_tonumber(ls,4);
	putpixel(aux,x1,y1,color);
	return 0;
}


int la_drawing_mode(lua_State *ls)
{
int mode;

	mode=(int)lua_tonumber(ls,1);
	drawing_mode(mode,NULL,0,0);
	return 0;
}

