#include <string.h>
#include <malloc.h>
#include "menu.h"
#include "mouse.h"
#include "log.h"
#include "trans.h"



TMENU * ph_init_menu(PHFONT *font)
{
TMENU *aux;
int i=0;

	ph_log(_("- Initiating menu: "));
	aux=(struct TMENU *)malloc(sizeof(struct TMENU));
	if (aux==NULL)
	{
		ph_log(_("Error.\n"));
		ph_log_memory_error("menu.c","ph_init_menu","aux",sizeof(struct TMENU));
	}
	else
		ph_log(_("Ok.\n"));
	
	memset(aux,0,sizeof(struct TMENU));
	
	for (i=0;i<MAXELEMENTS;i++)
	{
		aux->msg[i]=(char *)malloc(sizeof(char)*512);
		if (aux->msg[i]==NULL) ph_log_memory_error("menu.c","ph_init_menu","msg",sizeof(char)*512);
		memset(aux->msg[i],0,sizeof(char)*512);
		strcpy(aux->msg[i],"mierda");
	}
	
	ph_set_menu_defaults(aux);
	return aux;
}


void ph_destroy_menu(TMENU *tmenu)
{
int i;

	for (i=0;i<MAXELEMENTS;i++) free(tmenu->msg[i]);
	free(tmenu);
}


void ph_set_menu_defaults(TMENU * tmenu)
{
	tmenu->showmenu=1;
	tmenu->activemenu=MAIN_MENU;
}



void ph_set_menu_options(PHFONT *font, TMENU *tmenu)
{
int i;

	for (i=0;i<10;i++)
	{
		memset(tmenu->msg[i],0,sizeof(char)*512);
	}
	
	switch(tmenu->activemenu)
	{
		case INGAME_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=PLAY_MENU;
			tmenu->linknext[1]=INOPTIONS_MENU;
			tmenu->linknext[2]=RECORDS_MENU;
			strcpy(tmenu->msg[0],_("Resume the game"));
			strcpy(tmenu->msg[1],_("Game options"));
			strcpy(tmenu->msg[2],_("Return to the main screen"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case MAIN_MENU:
			tmenu->elements=4;
			tmenu->linknext[0]=PLAY_MENU;
			tmenu->linknext[1]=OPTIONS_MENU;
			tmenu->linknext[2]=RECORDS_MENU;
			tmenu->linknext[3]=EXIT_MENU;
			strcpy(tmenu->msg[0],_("Play"));
			strcpy(tmenu->msg[1],_("Game options"));
			strcpy(tmenu->msg[2],_("Records"));
			strcpy(tmenu->msg[3],_("Exit"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case OPTIONS_MENU:
			tmenu->elements=5;
			tmenu->linknext[0]=SCREEN_MENU;
			tmenu->linknext[1]=SOUND_MENU;
			tmenu->linknext[2]=CONTROL_MENU;
			tmenu->linknext[3]=GAME_MENU;
			tmenu->linknext[4]=MAIN_MENU;
			strcpy(tmenu->msg[0],_("Screen options"));
			strcpy(tmenu->msg[1],_("Sound options"));
			strcpy(tmenu->msg[2],_("Control options"));
			strcpy(tmenu->msg[3],_("Game options"));
			strcpy(tmenu->msg[4],_("Return to main menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case INOPTIONS_MENU:
			tmenu->elements=5;
			tmenu->linknext[0]=SCREEN_MENU;
			tmenu->linknext[1]=SOUND_MENU;
			tmenu->linknext[2]=CONTROL_MENU;
			tmenu->linknext[3]=GAME_MENU;
			tmenu->linknext[4]=INGAME_MENU;
			strcpy(tmenu->msg[0],_("Screen options"));
			strcpy(tmenu->msg[1],_("Sound options"));
			strcpy(tmenu->msg[2],_("Control options"));
			strcpy(tmenu->msg[3],_("Game options"));
			strcpy(tmenu->msg[4],_("Return to main menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case SCREEN_MENU:
			tmenu->elements=4;
			tmenu->linknext[0]=FULLSCREEN_MENU;
			tmenu->linknext[1]=RES_MENU;
			tmenu->linknext[2]=12;
			tmenu->linknext[3]=OPTIONS_MENU;
			strcpy(tmenu->msg[0],_("Fullscreen"));
			strcpy(tmenu->msg[1],_("Resolution"));
			strcpy(tmenu->msg[2],_("Scanlines"));
			strcpy(tmenu->msg[3],_("Return to options menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case SOUND_MENU:
			tmenu->elements=6;
			tmenu->linknext[0]=MUSIC_MENU;
			tmenu->linknext[1]=SFX_MENU;
			tmenu->linknext[2]=12;
			tmenu->linknext[3]=12;
			tmenu->linknext[4]=SURROUND_MENU;
			tmenu->linknext[5]=OPTIONS_MENU;
			strcpy(tmenu->msg[0],_("Music"));
			strcpy(tmenu->msg[1],_("Sound effects"));
			strcpy(tmenu->msg[2],_("Music volume"));
			strcpy(tmenu->msg[3],_("Sound effect volume"));
			strcpy(tmenu->msg[4],_("Surround"));
			strcpy(tmenu->msg[5],_("Return to options menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case CONTROL_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=CONTROLTYPE_MENU;
			tmenu->linknext[1]=12;
			tmenu->linknext[2]=OPTIONS_MENU;
			strcpy(tmenu->msg[0],_("Control type"));
			strcpy(tmenu->msg[1],_("Redefine keys"));
			strcpy(tmenu->msg[2],_("Return to options menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case CONTROLTYPE_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=CONTROL_MENU;
			tmenu->linknext[1]=CONTROL_MENU;
			tmenu->linknext[2]=CONTROL_MENU;
			strcpy(tmenu->msg[0],_("Keyboard"));
			strcpy(tmenu->msg[1],_("Joystick"));
			strcpy(tmenu->msg[2],_("Return to control menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case FULLSCREEN_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=SCREEN_MENU;
			tmenu->linknext[1]=SCREEN_MENU;
			tmenu->linknext[2]=SCREEN_MENU;
			strcpy(tmenu->msg[0],_("Fullscreen"));
			strcpy(tmenu->msg[1],_("Windowed"));
			strcpy(tmenu->msg[2],_("Return to screen menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case GAME_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=12;
			tmenu->linknext[1]=12;
			tmenu->linknext[2]=OPTIONS_MENU;
			strcpy(tmenu->msg[0],_("Game type"));
			strcpy(tmenu->msg[1],_("Show tips"));
			strcpy(tmenu->msg[2],_("Return to options menu"));
			tmenu->x=320;
			tmenu->y=220;
			break;
		case RES_MENU:
			tmenu->elements=5;
			tmenu->linknext[0]=SCREEN_MENU;
			tmenu->linknext[1]=SCREEN_MENU;
			tmenu->linknext[2]=SCREEN_MENU;
			tmenu->linknext[3]=SCREEN_MENU;
			tmenu->linknext[4]=SCREEN_MENU;
			strcpy(tmenu->msg[0],_("320 x 240"));
			strcpy(tmenu->msg[1],_("640 x 480"));
			strcpy(tmenu->msg[2],_("800 x 600"));
			strcpy(tmenu->msg[3],_("1024 x 768"));
			strcpy(tmenu->msg[4],_("Return to screen menu"));
			break;
		case MUSIC_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=SOUND_MENU;
			tmenu->linknext[1]=SOUND_MENU;
			tmenu->linknext[2]=SOUND_MENU;
			strcpy(tmenu->msg[0],_("Music on"));
			strcpy(tmenu->msg[1],_("Music off"));
			strcpy(tmenu->msg[2],_("Return to sound menu"));
			break;
		case SFX_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=SOUND_MENU;
			tmenu->linknext[1]=SOUND_MENU;
			tmenu->linknext[2]=SOUND_MENU;
			strcpy(tmenu->msg[0],_("Sound effects on"));
			strcpy(tmenu->msg[1],_("Sound effects off"));
			strcpy(tmenu->msg[2],_("Return to sound menu"));
			break;
		case SURROUND_MENU:
			tmenu->elements=3;
			tmenu->linknext[0]=SOUND_MENU;
			tmenu->linknext[1]=SOUND_MENU;
			tmenu->linknext[2]=SOUND_MENU;
			strcpy(tmenu->msg[0],_("Surround effect on"));
			strcpy(tmenu->msg[1],_("Surround effect off"));
			strcpy(tmenu->msg[2],_("Return to sound menu"));
			break;
	}

	tmenu->longerstring=0;

	for (i=0;i<tmenu->elements;i++)
	{
		if (ph_text_len(font,tmenu->msg[i]) > ph_text_len(font,tmenu->msg[tmenu->longerstring]))
		{
			tmenu->longerstring=i;
		}
	}
	
	tmenu->longerstring=ph_text_len(font,tmenu->msg[tmenu->longerstring]);
}



void ph_draw_menu(PHFONT *font, GFX *gfx, TMENU *tmenu, MOUSE *m)
{
int i;
BITMAP *bmp;

	
	if (tmenu->showmenu)
	{
		if (tmenu->ingame)
		{
			bmp=gfx->virt[0];
			tmenu->y=120;
		}
		else
		{
			tmenu->y=220;
			bmp=gfx->virt[6];
		}
			
		tmenu->x=(bmp->w>>1);
		
		ph_set_text_properties(font,makecol(100,150,100),-1,TXT_TITLE,TXT_CENTER,10,0,1);
		if (!tmenu->ingame) 
		{
			draw_sprite(bmp,gfx->logo,(bmp->w>>1)-(gfx->logo->w>>1),70);
			ph_text(bmp,font,(bmp->w>>1),160,_("Version 0.8"));
		}
		else 
		{
			draw_sprite(bmp,gfx->smalllogo,(bmp->w>>1)-(gfx->smalllogo->w>>1),40);
		}
		ph_set_text_properties(font,makecol(250,250,250),-1,TXT_TITLE,TXT_CENTER,22,0,1);
		
		set_trans_blender(127,127,127,127);
		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		
		rectfill(bmp,0,tmenu->y+(20*tmenu->actelement),639,tmenu->y+22+(20*tmenu->actelement),makecol(100,100,100));
		rectfill(bmp,2,tmenu->y+2+(20*tmenu->actelement),637,tmenu->y+20+(20*tmenu->actelement),makecol(100,100,100));
		
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		ph_set_text_properties(font,makecol(250,250,250),-1,TXT_TITLE,TXT_CENTER,22,0,1);
		//ph_draw_mouse(m,);
		rest(50);
		if (tmenu->showmenu)
		{
			for (i=0;i<tmenu->elements;i++)
				ph_printf(bmp,font,tmenu->x,tmenu->y+20*i,"%s",tmenu->msg[i]);
		}
	}
}

