/*
	path.c
	Author: Traperic <traperic@alamin.org>, (C) 2005.
	Copyright: See COPYING file that comes with this distribution.
*/

#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include "path.h"
#include "log.h"
#include "trans.h"


char * ph_init_path(void)
{
char *aux;

	aux=(char *)malloc(sizeof(char)*MAXPATHSIZE);
	if (aux==NULL)
		ph_log_memory_error("path.c","ph_get_path","aux",sizeof(char)*MAXPATHSIZE);
	return aux;
}


char * ph_get_path(CFG *cfg, char *path, char *buffer)
{
FILE *f,*f1;
	memset(path,0,sizeof(char)*MAXPATHSIZE);
	strcpy(path,cfg->prefix);
	strcat(path,buffer);
	f=fopen(path,"r");
	if (f==NULL)
	{
		memset(path,0,sizeof(char)*MAXPATHSIZE);
		strcpy(path,buffer);
		f1=fopen(path,"rb");
		if (f1==NULL)
		{
			ph_log(_("- Error: According to function ph_get_path the file %s doesn't exist.\n"),path);
			return NULL;
		}
		fclose(f1);
		return path;
	}
	fclose(f);
	return path;
}


void ph_destroy_path(char *path)
{
	free(path);
}
