#include "phttp1.h"


PHTTP * ph_init_phttp(void)
{
PHTTP *aux;
char *s_name;
char *f_url;
char *buf;


	aux=(struct PHTTP *)malloc(sizeof(struct PHTTP));
	memset(aux,0,sizeof(struct PHTTP));
	s_name=(char *)malloc(sizeof(char)*MAXSERVERNAME);
	memset(s_name,0,sizeof(char)*MAXSERVERNAME);
	f_url=(char *)malloc(sizeof(char)*MAXFINALURL);
	memset(f_url,0,sizeof(char)*MAXFINALURL);
	buf=(char *)malloc(sizeof(char)*MAXWEBBUFFER);
	memset(buf,0,sizeof(char)*MAXWEBBUFFER);
	aux->server_name=s_name;
	aux->final_url=f_url;
	aux->buffer=buf;
	#if HAVE_CURL_H
		aux->curl_handle=curl_easy_init();
	#endif
	return aux;
}


void ph_destroy_phttp(PHTTP *p)
{
	#if HAVE_CURL_H
		curl_easy_cleanup(p->curl_handle);
	#endif
	free(p->buffer);
	free(p->final_url);
	free(p->server_name);
	free(p);
}


int ph_set_server_name(PHTTP *p, char *name)
{
	if (name==NULL) return 0;
	if (strlen(name)+1>=MAXSERVERNAME) return 0;
	memset(p->server_name,0,sizeof(char)*MAXSERVERNAME);
	strcpy(p->server_name,name);
	return 1;
}


int ph_set_url(PHTTP *p, char *name)
{
	if (name==NULL) return 0;
	if (strlen(name)+1>=MAXFINALURL) return 0;
	memset(p->final_url,0,sizeof(char)*MAXFINALURL);
	strcpy(p->final_url,name);
	return 1;
}


char * ph_get_web(PHTTP *p)
{
	if (p->finished) return p->buffer;
	return 0;
}


size_t ph_write_memory_cb(void *ptr, size_t size, size_t nmemb, void *data)
{
size_t realsize = size * nmemb;
PHTTP *mem = (PHTTP *)data;

	mem->buffer = (char *)ph_my_realloc(mem->buffer, mem->size + realsize + 1);
	if (mem->buffer) 
	{
		memcpy(&(mem->buffer[mem->size]), ptr, realsize);
		mem->size += realsize;
		mem->buffer[mem->size] = 0;
	}
	return realsize;
}


void * ph_my_realloc(void *ptr, size_t size)
{
	if(ptr)
		return realloc(ptr, size);
	else
		return malloc(size);
}


int ph_obtain_web(void *me)
{
#if HAVE_CURL_H

PHTTP *p=(PHTTP *)me;

	curl_global_init(CURL_GLOBAL_ALL);

	do 
	{
		curl_easy_setopt(p->curl_handle, CURLOPT_URL, p->final_url);
		curl_easy_setopt(p->curl_handle, CURLOPT_WRITEFUNCTION, ph_write_memory_cb);
		curl_easy_setopt(p->curl_handle, CURLOPT_WRITEDATA, (void *)p);
		curl_easy_setopt(p->curl_handle, CURLOPT_TIMEOUT, 10);
		curl_easy_perform(p->curl_handle);
	}
	while(p->buffer==0);

	if (p->buffer!=0) p->finished=1;
#endif
	return 0;
}

