#include "traps.h"


void do_ball_trap(CONTROL *c, GFX *gfx, DATA *data, CFG *cfg, SOUND *sound, PLAYER *pl)
{
int sp=220;
int anim=0;

	pl->right=1;
	pl->x=itofix(220);
	pl->y=itofix(224);
	
	while(!key[KEY_ESC])
	{
		if (fixtoi(pl->x)!=448)
		{
			clear(gfx->virt[0]);
			sp=ph_control_in_trap(c,pl,sp);
			textprintf_ex(gfx->virt[0],font,10,40,makecol(255,255,255),-1,"speed: %d",sp);
			pl->x=itofix((sp/3));
			anim++;
			if (anim==10) anim=0;
			
			switch(anim)
			{
				case 0:draw_sprite(gfx->virt[0],gfx->phspr[0],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 1:draw_sprite(gfx->virt[0],gfx->phspr[0],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 2:draw_sprite(gfx->virt[0],gfx->phspr[0],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 3:draw_sprite(gfx->virt[0],gfx->phspr[1],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 4:draw_sprite(gfx->virt[0],gfx->phspr[1],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 5:draw_sprite(gfx->virt[0],gfx->phspr[2],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 6:draw_sprite(gfx->virt[0],gfx->phspr[2],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 7:draw_sprite(gfx->virt[0],gfx->phspr[2],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 8:draw_sprite(gfx->virt[0],gfx->phspr[1],fixtoi(pl->x),fixtoi(pl->y));
				break;
				case 9:draw_sprite(gfx->virt[0],gfx->phspr[1],fixtoi(pl->x),fixtoi(pl->y));
				break;
			}
			blit(gfx->virt[0],screen,0,0,0,0,640,480);
			
		}
		else
		{
			break;
		}
		
		#if HAVE_ALDUMB_H
			al_poll_duh(sound->music->mpl);
		#endif

	}
}

	


int ph_control_in_trap(CONTROL *c,PLAYER *pl, int speed)
{
static int keyvp=0;
static int keybp=0;
	
	switch(c->type)
	{
		case CTRL_TYPE_KEYBOARD:
			if (c->polling) poll_keyboard();
			
			if (key[(int)c->key[MOVE_LEFT]] && !keyvp && !key[(int)c->key[MOVE_RIGHT]]) 
			{
				keyvp=1;
				keybp=0;
				speed+=15;
			}
			if (key[(int)c->key[MOVE_RIGHT]] && !keybp && !key[(int)c->key[MOVE_LEFT]]) 
			{
				keybp=1;
				keyvp=0;
				speed+=15;
			}
			break;
		
		case CTRL_TYPE_JOYSTICK:
			
			poll_joystick();
			if (joy[0].stick[0].axis[0].d1 && !keyvp && !joy[0].stick[0].axis[0].d2) 
			{
				keyvp=1;
				keybp=0;
				speed+=15;
			}
			if (joy[0].stick[0].axis[0].d2 && !keybp && !joy[0].stick[0].axis[0].d1)
			{
				keyvp=0;
				keybp=1;
				speed+=15;
			}
			break;
		
		default:
			
			break;
	}
	
	if (pl->aniframe>=itofix(4)) pl->aniframe=itofix(0);
	if (speed>180) speed--;
	return speed;	
}


